<?php
$initBlock=TRUE;
$blacklist_typeInfo =
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "auto increment",
                "form hidden"
            ),
            "block"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "min" =>"1",
                "list",
                "not null"
            ),
            "ownerId"=>array(
                "type"=>"INT",
                "unsigned",
                "form invisible",
                "private"
            )
        ),
        "primary_key"=>array(
            "id"
        ),
        "tableName"=>"blacklist_zorum"
    );
class Blacklist extends Object
{
    function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
    {
        global $zorumrecognised, $zorumuser;
        global $generalRight;
        $generalRight = TRUE;
        if( $zorumrecognised && $zorumuser->isAdm=="yes" )
        {
            $hasRight=TRUE;
        }
        else
        {
            $hasRight=FALSE;
        }
        if( !$hasRight && $giveError )
        {
            global $infoText;
            global $errTxt;
            $txt = $errTxt[permission_denied];
            $infoText[] = $txt;
            return permission_denied;
        }
        return ok;
    }
    function create($overrulePrivilege=FALSE)
    {
        global $zorumuser;
        global $infoText;
        global $whatHappened;
        global $submit;
        global $langTxt;
        $whatHappened = "form_submitted";
        if( $submit==$langTxt["cancel"] )
        {   
            $infoText[] = $langTxt["operation_cancelled"];
            return ok;
        } 
        hasAdminRights($isAdmin);
        if (!$isAdmin) {
            $infoText[] = $langTxt["permission_denied"];
            return permission_denied;
        }
        $ret = privilegeCreate($this, $overrulePrivilege);
        return $ret;     
    }
    function delete($whereFields="",$overrulePrivilege=FALSE)
    {
        global $submit;
        global $langTxt;
        global $whatHappened;
        global $infoText;
        global $zorumroll;
        $whatHappened = "form_submitted";
        if( $submit==$langTxt["no"] )
        {   
            $infoText[] = $langTxt["operation_cancelled"];
            return ok;
        } 
        $ret=privilegeDelete($this,$whereFields="",$overrulePrivilege);
        if ($ret==not_found_in_db) {
            $infoText[] = $langTxt["no_such_object"];
            return ok;
        }
        if ($ret!=ok) {
            return $ret;
        }
        if( $zorumroll->frommethod=="showdetails" )      
        {
            $zorumroll->frommethod = "showhtmllist";
            $zorumroll->fromid = 0;
        }
        return ok;     
    }  
    function showNavBar(&$s)
    {
        global $zorumroll; 
        global $langTxt;
        $s = "";
        goForward( $tempRoll, "forums" );
        $s.=$tempRoll->generAnchor($langTxt["forums"]);
        $s.="&nbsp;>&nbsp;";
        if( $zorumroll->method=="showhtmllist" )
        {
            $s.=$langTxt["blacklist"];
        }
        else
        {
            goForward( $tempRoll, "blackList", $this );
            $s.=$tempRoll->generAnchor($langTxt["blacklist"]);
        }    
        $s=insertSpanClass( $s, "navBar" );
        return ok;
    }
}
function blockBlacklist(&$what)
{
    global $REMOTE_ADDR;
    global $zorumuser,$zorumauthlevel,$errTxt;
    global $blacklist_typeInfo;
    $what="";
    $query="SELECT block from ".$blacklist_typeInfo["tableName"].
           " WHERE block='".addcslashes($zorumuser->name,"'")."' OR".
           " block='".$REMOTE_ADDR."'";
    if (isset($zorumuser->email) && $zorumuser->email!="") {
        $query.=" OR block='$zorumuser->email'";
    }
    $result=mysql_query($query);
    if( $result==0 ) {
        return general_mysql_error;
    }
    $num=mysql_num_rows($result);
    if ($num>0) {
        $row=mysql_fetch_row($result);
        $what=$row[0];
        $zorumauthlevel=Loginlib_NewUser;
    }
    return ok;
}
?>
