<?php
$style_typeInfo = 
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "auto increment",
                "form hidden"
            ),
            "name"=>array(
                "type"=>"VARCHAR",
                "max" =>"120",
                "min" =>"1",
                "not null",
                "list",
                "sorta"
            ),
            "bg"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "textcol"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "linkcol"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "line"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "cellbg"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "cellbg0"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "cellbg1"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "cellbg2"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "cellbg3"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "cellbg4"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "headbg"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "category"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "statbg"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "loginbg"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "menubg"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "menubgsel"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "jumpbg"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "poweredcol"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "thboxheaderbg"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "thboxcellbg"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "thboxactcellbg"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "thboxfooterbg"=>array(
                "type"=>"VARCHAR",
                "max" =>"50",
                "min" =>"1",
                "not null"
            ),
            "ownerId"=>array(
                "type"=>"INT",
                "unsigned",
                "form invisible",
                "private"
            )       
        ),
        "primary_key"=>array( "id"),
        "tableName"=>"style_zorum",
        "sorta"=>"name"
    );
class Style extends Object
{
    function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
    {
        global $zorumrecognised, $zorumuser;
        global $generalRight;
        $generalRight = TRUE;
        if( $zorumrecognised && $zorumuser->isAdm=="yes" )
        {
            $hasRight=TRUE;
        }
        elseif( $method==Priv_load )
        {
            $hasRight=TRUE;
        }
        else
        {
            $hasRight=FALSE;
        }
        if( !$hasRight && $giveError )
        {
            global $infoText;
            global $errTxt;
            $txt = $errTxt[permission_denied];
            $infoText[] = $txt;
            return permission_denied;
        }
        return ok;
    }
    function generCss(&$s, $onlyTheForwarderStyles=FALSE)
    {
        global $zorumfontstylesheet, $zorumcolorstylesheet;
        $s="";
        $s.= "<STYLE TYPE='text/css'>\n";
        $s.= "<!--\n";
        if( !$onlyTheForwarderStyles )
        {
            $s.= ".headerbg { background-color:".$this->headbg."; }\n".
             ".statbg {background-color:".$this->statbg."; }\n".
             ".loginbg {background-color:".$this->loginbg."; }\n".
             ".forumrow {background-color:".$this->cellbg."; }\n".
             ".forumrow0 {background-color:".$this->cellbg0."; }\n".
             ".forumrow1 {background-color:".$this->cellbg1."; }\n".
             ".forumrow2 {background-color:".$this->cellbg2."; }\n".
             ".forumrow3 {background-color:".$this->cellbg3."; }\n".
             ".forumrow4 {background-color:".$this->cellbg4."; }\n".
             ".category { background-color:".$this->category."; }\n".
             ".table { background-color:".$this->line."; }\n".
             ".menubg { background-color:".$this->menubg."; }\n".
             ".menubgsel { background-color:".$this->menubgsel."; }\n".
             ".jumpbg { background-color:".$this->jumpbg."; }\n".
             ".bodybg { background-color:".$this->bg."; }\n".
             ".boxhead { background-color:".$this->thboxheaderbg."; }\n".
             ".boxcell { background-color:".$this->thboxcellbg."; }\n".
             ".boxactcell { background-color:".$this->thboxactcellbg."; }\n".
             ".boxfooter { background-color:".$this->thboxfooterbg."; }\n".
             ".powered { text-align:center;".
                        " color:".$this->poweredcol."; }\n".
             ".stylebox { border-color: #C8D1F7; border-style: outset; }\n".
             ".nonavstyle { text-decoration: none; color: black;}\n".
             "a:link, a:visited, a:active {color:".$this->linkcol.";}\n";
        } 
        else
        {
             $s.= ".powered { text-align:center;".
                        " color:".$this->poweredcol."; }\n";
        }    
        if( isset($zorumfontstylesheet) )
        {
            if( !$onlyTheForwarderStyles )
            {                 
                $typ = $zorumfontstylesheet->getTypeInfo();
                foreach( $typ["attributes"] as $attr=>$attrInfo )
                {
                    if( in_array("style", $attrInfo) )
                    {
                        $s1="";
                        if( isset($zorumfontstylesheet->{$attr}) && 
                            $zorumfontstylesheet->{$attr}!="" )
                        {
                            $s1.=$zorumfontstylesheet->{$attr};
                        }    
                        if( isset($zorumcolorstylesheet->{$attr}) && 
                            $zorumcolorstylesheet->{$attr}!="" )
                        {
                            $s1.=$zorumcolorstylesheet->{$attr};
                        } 
                        if( $s1!="" )
                        {   
                            $s .= ".$attr { $s1 }\n";
                        }
                    }    
                } 
            }
            else
            {
                $s1=$zorumfontstylesheet->messageLine;
                $s1.=$zorumcolorstylesheet->messageLine;
                $s .= ".messageLine { $s1 }\n";
            }  
        }
        $s.= "-->\n".
             "</STYLE>";
        return ok;
    }
    function showNavBar(&$s)
    {
        global $zorumroll; 
        global $langTxt;
        $s = "";
        goForward( $tempRoll, "forums" );
        $s.=$tempRoll->generAnchor($langTxt["forums"]);
        $s.="&nbsp;>&nbsp;";
        if( $zorumroll->method=="showhtmllist" )
        {
            $s.=$langTxt["styles"];
        }
        else
        {
            goForward( $tempRoll, "styles", $this );
            $s.=$tempRoll->generAnchor($langTxt["styles"]);
        }    
        $s=insertSpanClass( $s, "navBar" );
        return ok;
    }
    function delete($whereFields="",$overrulePrivilege=FALSE)
    {
        global $submit;
        global $langTxt;
        global $whatHappened;
        global $infoText;
        global $zorumroll;
        $whatHappened = "form_submitted";
        if( $submit==$langTxt["no"] )
        {   
            $infoText[] = $langTxt["operation_cancelled"];
            return ok;
        } 
        $ret=privilegeDelete($this,$whereFields="",$overrulePrivilege);
        if ($ret==not_found_in_db) {
            $infoText[] = $langTxt["no_such_object"];
            return ok;
        }
        if ($ret!=ok) {
            return $ret;
        }
        if( $zorumroll->frommethod=="showdetails" )      
        {
            $zorumroll->frommethod = "showhtmllist";
            $zorumroll->fromid = 0;
        }
        return ok;     
    }  
}
function loadStyleHeader()
{
    global $colorStyle,$zorumSkin;
    global $zorumroll;
    $zorumSkin = new Style;
    $zorumSkin->id=$colorStyle;
    $ret=load($zorumSkin);
    if ($ret!=ok) {
        global $infoText;
        global $langTxt, $errTxt;
        $txt = $errTxt[not_found_in_db];
        $infoText[] = $langTxt["STY10"].": ".$txt;
        return $ret;
    }
    return ok;
}
function showStyleHeader(&$s, $onlyTheForwarderStyles=FALSE)
{
    global $colorStyle,$zorumSkin;
    global $zorumroll;
    global $bodyBgImg;
    $s="";
    $s.= "<body bgcolor='$zorumSkin->bg' text='$zorumSkin->textcol'";
    if (isset($bodyBgImg)) $s.=" background='$bodyBgImg'";
    $s.=">\n";
    $ret=$zorumSkin->generCss($s1, $onlyTheForwarderStyles);
    if ($ret!=ok) {
        return $ret;
    }
    $s.=$s1;
    return ok;
}
?>
