<?php
function forumforum_showNavBar(&$base,&$s, $withLink=FALSE)
{
    global $zorumroll; 
    global $langTxt;
    global $rollid;
    global $forumView;
    $s="";
    if( $zorumroll->method=="showhtmllist" )
    {
        if( !$rollid || $forumView=="tree" ) $s.=$langTxt["forums"];
        else
        {
            goForward( $tempRoll, "forums", $base );
            $s.=$tempRoll->generAnchor($langTxt["forums"]);
            $s.="&nbsp;>&nbsp;";
            $ret = $base->cacheFatherObjects();
            if( $ret ) {
                return $ret;
            } 
            global $fatherForumList;
            if( $withLink )
            {
                $base->pid = $base->id;
                goForward( $tempRoll, "topics", $base );
                $s1=$tempRoll->generAnchor($base->name);
            }
            else $s1=$base->name;
            foreach( $fatherForumList as $fatherForum )
            {
                goForward( $tempRoll, "subForum", $fatherForum );
                $s1 = $tempRoll->generAnchor($fatherForum->name)."&nbsp;>&nbsp;$s1";
            }
            $s.=$s1;
        }
    }
    elseif( $zorumroll->method=="treeorganiser_form"  )
    {
        goForward( $tempRoll, "forums", $base );
        $s.=$tempRoll->generAnchor($langTxt["forums"]);
        $s.="&nbsp;>&nbsp;";
        $s.=$langTxt["organiseForum"];
    }
    else
    {
        goForward( $tempRoll, "forums", $base );
        $s.=$tempRoll->generAnchor($langTxt["forums"]);
    }
    $s=insertSpanClass( $s, "navBar" );
    return ok;
}
function forumforum_showListVal(&$base,$attr, $index="", $filledFromSavedValues=TRUE)
{
    global $langTxt;
    global $zorumuser;
    global $zorumroll;
    $s="";
    global $readAccessArr;
    $ret=readAccessForums();
    if( $ret ) {
        return $ret;
    } 
    if ($attr=="creationtime") {
        $s=showTimestamp($base->{$attr});
    }
    else if ($attr=="lastpost") {
        $s = $base->{$attr}=="0" ? 
             $langTxt["never"] : showTimestamp($base->{$attr});
    }
    elseif($attr=="iscat") {
        $s=$langTxt[$base->{$attr}];
    }    
    else if ($attr=="status") {
        if ($base->{$attr}=="forum_opened") {
            $cookieName="readforum_".$base->id;
            global $$cookieName;             
            if ($base->lastpost<=$zorumuser->logoutTime ||
               (isset($$cookieName)&&$base->lastpost<=$$cookieName))
            {
                $s=$base->showNoNewmessForumImage();
            }
            else $s=$base->showNewmessForumImage();
        }
        else $s=$base->showClosedForumImage();
    }
    else if ($attr=="moderator") {
        $mods=explode(",",$base->moderator);
        if (isset($mods[0])&&$mods[0]!="") {
            for($i=0;isset($mods[$i]);$i++) {
                if ($s!="") $s.=",";
                $mod=trim($mods[$i]);
                $mod=showUserLink($mod);
                $s.=$mod;
            }
            return $s;
        }
        if ($s=="") $s=$langTxt["notmoderated"];
    }
    else if( $attr=="name" )
    {
        $s=htmlspecialchars($base->{$attr});
        hasAdminRights($isAdm);
        if (isset($readAccessArr[$base->id]) || $base->readgroup==0 ||
            $isAdm)
        {
            goForward( $tempRoll, "forumName", $base );
            $s=$tempRoll->generAnchor($s, "listItemTitle");
        }
        global $forumView;
        if( $forumView=="flat" && $base->hasChild=="yes" &&
            $zorumroll->method!="treeorganiser_form" )
        {
            goForward( $tempRoll, "subForum", $base );
            $s.="&nbsp;&nbsp;";
            $s.=$tempRoll->generAnchor($langTxt["subForum"], "listItem");
        }
        if ($base->description!="") {
            $s.="<br><span class='forumDescription'>";
            $s.=htmlspecialchars($base->description);
            $s.="</span>";
        }
        $first=TRUE;
        if ($base->readgroup!=0) {
            $s.="<br><span class='forumAccess'>";
            $s.=$langTxt["private_read"];
            $s.="</span>";
            $first=FALSE;
        }
        if ($base->writegroup!=0) {
            if ($first) $s.="<br>";
            else $s.="&nbsp;-&nbsp;";
            $s.="<span class='forumAccess'>";
            $s.=$langTxt["private_write"];
            $s.="</span>";
            $first=FALSE;
        }
        if ($base->topicgroup!=0) {
            if ($first) $s.="<br>";
            else $s.="&nbsp;-&nbsp;";
            $s.="<span class='forumAccess'>";
            $s.=$langTxt["private_topic"];
            $s.="</span>";
            $first=FALSE;
        }
        if ($base->allowAnonym=="yes") {
            if ($first) $s.="<br>";
            else $s.="&nbsp;-&nbsp;";
            $s.="<span class='forumAccess'>";
            $s.=$langTxt["forum_allowAnonym"];
            $s.="</span>";
            $first=FALSE;
        }
        return $s;
    }
    else if( $attr=="treeidx" )
    {
        if( $filledFromSavedValues ) 
        {
            $value = $base->treeidx;
        }
        else
        {
            $treeidx_name = "treeidx_$index";
            global $$treeidx_name;
            $value = $$treeidx_name;
        }
        return "<input type='text' name='treeidx_$index' value='$value' class='forumrow' maxlength='4' size='4'>";
    }
    else if( $attr=="treedepth" )
    {
        if( $filledFromSavedValues ) 
        {
            $value = $base->treedepth;
        }
        else
        {
            $treedepth_name = "treedepth_$index";
            global $$treedepth_name;
            $value = $$treedepth_name;
        }
        if( $value=="" ) $value=0;
        return "<input type='text' name='treedepth_$index' value='$value' class='forumrow' maxlength='4' size='4'>";
    }
    else
    {
        $s=htmlspecialchars($base->{$attr});
    }
    $s=insertSpanClass($s, "listItem");
    return $s;
} 
function forumforum_showBelowList(&$base,&$s)
{
    global $langTxt;
    $s="";
    $s.="<table border='0' cellspacing='0'><tr class='forumrow'>";
    $s.="<td valign='center'>".$base->showNoNewmessForumImage().
        "</td>\n";
    $s.="<td valign='center'>:".  $langTxt["nonewmess"].
        " </td>\n";
    $s.="<td valign='center'>".$base->showNewmessForumImage().
        "</td>\n";
    $s.="<td valign='center'>:".$langTxt["newmess"].
        " </td>\n";
    $s.="<td valign='center'>".$base->showClosedForumImage().
        " </td>\n";
    $s.="<td valign='center'>:".$langTxt["closedforum"]."</td>\n";
    $s.="</tr></table>\n";
    $s=insertSpanClass($s, "explanationBar");
    return ok;
}
function forumforum_showDetailsMethods(&$base)
{
    global $subscription,$subsInfo,$langTxt,$zorumuser;
    global $zorumrecognised, $zorumauthlevel;
    $s="";
    if(($zorumrecognised || $zorumauthlevel==Loginlib_GuestLevel)) {
        $s.="<tr><td class='forumrow' colspan='2'>";
        if ($subscription&fav_forum &&
            isset($subsInfo["favforum"][$base->id]))
        {
            goForward( $tempRoll, "unsubscribe");
            $txt=$langTxt["delfav_forum"];
        }
        else {
            goForward( $tempRoll, "subscribe");
            $txt=$langTxt["fav_forum"];
        }
        $tempRoll->type=fav_forum;
        $tempRoll->classid=$base->id;
        $s.=$tempRoll->generAnchor($txt,"listItem");
        $s.="</td></tr>\n";
    }
    if ($zorumrecognised) {
        $s.="<tr><td class='forumrow' colspan='2'>";
        if ($subscription&subs_forum_new_mess &&
            isset($subsInfo["forummess"][$base->id]))
        {
            goForward( $tempRoll, "unsubscribe");
            $tempRoll->type=subs_forum_new_mess;
            $tempRoll->classid=$base->id;
            $txt=$langTxt["unsubs_forum_new_mess"];
        }
        else 
        {
            goForward( $tempRoll, "subscribe");
            $tempRoll->type=subs_forum_new_mess;
            $tempRoll->classid=$base->id;
            $txt=$langTxt["subs_forum_new_mess"];
        }    
        $s.=$tempRoll->generAnchor($txt,"listItem");
        $s.="</td></tr>\n";
        $s.="<tr><td class='forumrow' colspan='2'>";
        if ($subscription&subs_forum_new_topic &&
            isset($subsInfo["forumtopic"][$base->id]))
        {
            goForward( $tempRoll, "unsubscribe");
            $tempRoll->type=subs_forum_new_topic;
            $tempRoll->classid=$base->id;
            $txt=$langTxt["unsubs_forum_new_topic"];
        }
        else 
        {
            goForward( $tempRoll, "subscribe");
            $tempRoll->type=subs_forum_new_topic;
            $tempRoll->classid=$base->id;
            $txt=$langTxt["subs_forum_new_topic"];
        }    
        $s.=$tempRoll->generAnchor($txt,"listItem");
        $s.="</td></tr>\n";
    }
    return $s;      
} 
function forumforum_generForm(&$base,&$s)
{
    global $langTxt,$zorumuser,$forum_typeInfo;
    global $usedInPortal,$portalNiceUrl;
    $s="";
    $groups = new Group;
    $query="SELECT id, name FROM group_zorum ORDER BY name";
    $ret=loadObjectsSQL( $groups,$query,$groups);
    if ($ret!=not_found_in_db && $ret!=ok) {
        return $ret;
    }
    $typ = & $forum_typeInfo;
    if( !$usedInPortal || $portalNiceUrl=="no") {
        $forum_typeInfo["attributes"]["niceurl"][] = 
            "no column";
    } 
    $typ["attributes"]["readgroup"]["type"] = "ENUM";
    $typ["attributes"]["readgroup"]["values"][0] = 0;
    foreach( $groups as $group )
    {
        $typ["attributes"]["readgroup"]["values"][$group->id] = 
            $group->id;
        $langTxt["forum_$group->id"]=$group->name;   
    }        
    $typ["attributes"]["readgroup"]["values"][Group_OnlyAdmin] = 
        Group_OnlyAdmin;
    $typ["attributes"]["writegroup"]["type"] = "ENUM";
    $typ["attributes"]["writegroup"]["values"][0] = 0;
    foreach( $groups as $group )
    {
        $typ["attributes"]["writegroup"]["values"][$group->id] = 
            $group->id;
        $langTxt["forum_$group->id"]=$group->name;   
    }        
    $typ["attributes"]["writegroup"]["values"][Group_OnlyAdmin] = 
        Group_OnlyAdmin;
    $typ["attributes"]["topicgroup"]["type"] = "ENUM";
    $typ["attributes"]["topicgroup"]["values"][0] = 0;
    foreach( $groups as $group )
    {
        $typ["attributes"]["topicgroup"]["values"][$group->id] = 
            $group->id;
        $langTxt["forum_$group->id"]=$group->name;   
    }        
    $typ["attributes"]["topicgroup"]["values"][Group_OnlyAdmin] = 
        Group_OnlyAdmin;
    $ret = generForm($base,$s1);
    $s.=$s1;
    return $ret;
}
?>
