<?php
$forummessage_typeInfo = 
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "auto increment",
                "form hidden"
            ),
            "up"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "form hidden",
                "private"
            ),
            "treeidx"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "form hidden",
                "private"
            ),            
            "treedepth"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "form hidden",
                "private"
            ),                        
            "pid"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "form hidden",
                "private"
            ),
            "tid"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "form hidden",
                "private"
            ),
            "subject"=>array(
                "type"=>"VARCHAR",
                "max" =>"250",
                "min" =>"1",
                "list",
                "not null",
                "sorta"
            ),
            "f_wholeniceurl"=>array(
                "type"=>"VARCHAR",
                "max" =>"250",
                "no column"
            ),
            "t_wholeniceurl"=>array(
                "type"=>"VARCHAR",
                "max" =>"250",
                "no column"
            ),
            "forumname"=>array(
                "type"=>"VARCHAR",
                "max" =>"120",
                "no column",
                "sorta"
            ),
            "viewnum"=>array(
                "type"=>"INT",
                "no column"
            ),
            "postnum"=>array(
                "type"=>"INT",
                "no column"
            ),
            "topicsubject"=>array(
                "type"=>"VARCHAR",
                "max" =>"250",
                "no column",
                "sorta"
            ),
            "descriptionTxt"=>array(
                "type"=>"TEXT",
                "not null"
            ),
            "txt"=>array(
                "type"=>"TEXT",
                "not null"
            ),
            "hasanswer"=>array(
                "type"=>"INT",
                "length"=>1,
                "not null",
                "default"=>"0",
                "form hidden",
                "private"
            ),           
            "creationtime"=>array(
                "type"=>"INT",
                "form invisible",
                "list",
                "sorta",
                "private"
            ),           
            "iplog"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "form invisible",
                "private"
            ),
            "creator"=>array(
                "type"=>"VARCHAR",
                "max" =>"32",
                "list",
                "not null",
                "form hidden",
                "private",
                "sorta"
            ),
            "subs_topic"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "not null",
                "default"=>"no",
                "no column"
            ),            
            "subs_mess"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "not null",
                "default"=>"no",
                "no column"
            ),                        
            "ratenum"=>array(
                "type"=>"INT",
                "default"=>"0",
                "form invisible",
                "private"
            ),            
            "rateavg"=>array(
                "type"=>"FLOAT(2,1)",
                "default"=>"0",
                "form invisible",
                "private"
            ),            
            "rate"=>array(
                "type"=>"FLOAT(2,1)",
                "default"=>"0",
                "list",
                "sorta",
                "no column",
                "private"
            ),            
            "MAX_FILE_SIZE"=>array(
                "type"=>"INT",
                "form hidden",
                "not null",
                "no column"
            ),
            "att_file_upload"=>array(
                "type"=>"VARCHAR",
                "max" =>"250",
                "not null"
            ),
            "attsize"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "form invisible",
                "private"
            ),            
            "downloaded"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "form invisible",
                "private"
            ),            
            "blockPosition"=>array(
                "type"=>"INT",
                "form hidden",
                "not null",
                "private",
                "unsigned"
            ),            
            "coding"=>array(
                "type"  =>"ENUM",
                "values"=>array( "HTML", "UBB", "no" ),
                "not null",
                "default"=>"no"
            ),            
            "smiley"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "not null",
                "default"=>"yes"
            ),            
            "ownerId"=>array(
                "type"=>"INT",
                "unsigned",
                "form invisible",
                "private"
            )           
        ),
        "primary_key"=>array( "id"),
        "tableName"=>"forummessage_zorum",
        "notools",
        "submit"=>array("ok", "cancel", "preview")
    );
class ForumMessage extends Object
{
    function ForumMessage()
    {
        global $forummessage_typeInfo;
        $this->up=0;
    }
    function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
    {
        global $zorumrecognised, $zorumauthlevel, $zorumuser,$zorumroll;
        global $generalRight;
        $generalRight = FALSE;
        $hasRight = FALSE;
        $ret = $this->cacheFatherObjects("forum, topic");
        if ($ret!=ok) {
            return $ret;
        }        
        global $fatherForum, $fatherTopic;
        global $readAccessArr;
        if ($fatherForum->readgroup!=0 ) {
            $ret=readAccessForums();
            if( $ret ) {
                return $ret;
            } 
        }
        hasAdminRights($isAdm);
        if (isset($readAccessArr[$fatherForum->id]) ||
            $fatherForum->readgroup==0 || $isAdm)
        {
            $readRight=TRUE;
        }
        else $readRight=FALSE;
        global $writeAccessArr;
        if ($fatherForum->writegroup!=0) {
            $ret=writeAccessForums();
            if( $ret ) {
                return $ret;
            } 
        }
        if (isset($writeAccessArr[$fatherForum->id]) ||
            $fatherForum->writegroup==0 || $isAdm)
        {
            $writeRight=TRUE;
        }
        else $writeRight=FALSE;        
        if( $method==Priv_load )
        {
            $hasRight=$readRight;
            $generalRight = TRUE;
        }
        elseif( $zorumauthlevel==Loginlib_NewUser )
        {
            $hasRight=FALSE;
            $generalRight = TRUE;
        }  
        elseif( $zorumauthlevel==Loginlib_GuestLevel && 
                $fatherForum && $fatherForum->allowAnonym=="no" )
        {
            $hasRight=FALSE;
            $generalRight = TRUE;
        }        
        elseif( $zorumauthlevel>Loginlib_GuestLevel && 
                !$zorumrecognised )
        {
            $hasRight=FALSE;
            $generalRight = TRUE;
        }        
        else
        {
            if( $fatherForum && $fatherForum->status=="forum_closed" ||
                $fatherTopic && $fatherTopic->status=="forum_closed" ) 
            {
                $hasRight=FALSE;
                $generalRight=($zorumroll->class=="forummessage");
            }
            elseif( $method==Priv_create )
            {
                $hasRight=$writeRight;
                $generalRight = TRUE;
            }
            elseif( $zorumuser->isAdm=="yes" )
            {
                $hasRight=TRUE;
                $generalRight = TRUE;
            }
            elseif( $zorumuser->isMod=="yes" )
            {
                if( $fatherForum )
                {
                    $moderators = split( ", *", $fatherForum->moderator );
                    if( in_array($zorumuser->name, $moderators) )
                    {
                        $hasRight=TRUE;
                        $generalRight=($zorumroll->class=="forummessage");
                    }    
                }
            }
            if( !$hasRight && isset($this->ownerId) && 
                $this->ownerId==$zorumuser->id )
            {
                $generalRight = FALSE;
                if( $this->hasanswer!="0" )
                {
                    $hasRight=FALSE;
                }
                else
                {
                    $hasRight=$writeRight;
                }
            }
        }
        if( !$hasRight && $giveError )
        {
            global $infoText;
            global $errTxt;
            $txt = $errTxt[permission_denied];
            $infoText[] = $txt;
            return permission_denied;
        }
        return ok;
    }
    function create($overrulePrivilege=FALSE)
    {
        return forummessage_create($this,$overrulePrivilege);
    }
    function modify($whereFields="", $overrulePrivilege=FALSE )
    {
        return forummessage_modify($this,$whereFields,
                                   $overrulePrivilege);
    }
    function delete($whereFields="", $overrulePrivilege=FALSE)
    {
        return forummessage_delete($this,$whereFields,
                                   $overrulePrivilege);
    }
    function showDelToolPlusUrl(&$roll)
    {
        $roll->up = $this->up;
    } 
    function createForm(&$s,$valid=TRUE)
    {
        return forummessage_createForm($this,$s,$valid);
    }       
    function createFormInvalid(&$s)
    {
        return forummessage_createFormInvalid($this,$s);
    }
    function modifyForm(&$s,$valid=TRUE)
    {
        return forummessage_modifyForm($this,$s,$valid);
    }
    function modifyFormInvalid(&$s)
    {
        return forummessage_modifyFormInvalid($this,$s);
    }
    function generForm(&$s)
    {
        return forummessage_generForm($this,$s);
    }
    function showPreview()
    {
        return forummessage_showPreview($this);
    }
    function loadHtmlList(&$list)
    {
        return forummessage_loadHtmlList($this,$list);
    }
    function showHtmlList(&$s)
    {
        return forummessage_showHtmlList($this,$s);
    }
    function showNavBar(&$s)
    {
        return forummessage_showNavBar($this,$s);
    }
    function showReplyTool(&$s,$noquote=TRUE)
    {
        return forummessage_showReplyTool($this,$s,$noquote);
    }
    function showListVal($attr, $rights)
    {
        return forummessage_showListVal($this,$attr, $rights);
    }
    function showNewTool(&$s,$rights)
    {
        return forummessage_showNewTool($this,$s,$rights);
    }
    function showNewToolPlusUrl(&$roll)
    {
        return forummessage_showNewToolPlusUrl($this,$roll);
    }
    function showJumperTool(&$s)
    {
        return forummessage_showJumperTool($this,$s);
    }
    function viewChange(&$s)
    {
        return forummessage_viewChange($this,$s);
    }
    function showSortTool($attr)
    {
        return forummessage_showSortTool($this,$attr);
    }
    function showDetailsMethods()
    {
        return forummessage_showDetailsMethods($this);
    }    
    function cacheFatherObjects( $whichObjects="forum, topic" )
    {
        $whichObjects=split( ", *", $whichObjects );
        if( in_array( "forum", $whichObjects ) )
        {
            global $fatherForum;
            if( isset($this->pid) && $this->pid && 
                (!isset($fatherForum) || !$fatherForum ||
                $fatherForum->id!=$this->pid) ) 
            {
                $fatherForum=new Forum;
                $fatherForum->id=$this->pid;
                $ret=load($fatherForum);
                if( $ret==general_mysql_error ) 
                {
                    return $ret;
                }
                else if( $ret==not_found_in_db ) $fatherForum=0;
            }
            else if( !isset($this->pid) || !$this->pid ) $fatherForum=0;
            if( !$fatherForum )
            {
            }    
        }    
        if( in_array( "topic", $whichObjects ) )
        {
            global $fatherTopic;
            if( isset($this->tid) && $this->tid &&
                (!isset($fatherTopic) || !$fatherTopic || 
                 $fatherTopic->id!=$this->tid) ) 
            {
                $fatherTopic=new ForumTopic;
                $fatherTopic->id=$this->tid;
                $ret=load($fatherTopic);
                if( $ret==general_mysql_error ) 
                {
                    return $ret;
                }
                else if( $ret==not_found_in_db ) $fatherTopic=0;
            }
            else if( !isset($this->tid) || !$this->tid ) $fatherTopic=0;
            if( !$fatherTopic )
            {
            }    
        }    
        if( in_array( "message", $whichObjects ) )
        {
            global $fatherMessage;
            if( (!isset($fatherMessage) || !$fatherMessage || 
                $fatherMessage->id!=$this->up )
                && $this->up!=0 ) 
            {
                $fatherMessage=new ForumMessage;
                $fatherMessage->id=$this->up;
                $ret=load($fatherMessage);
                if( $ret==general_mysql_error ) 
                {
                    return $ret;
                }
                else if( $ret==not_found_in_db ) $fatherMessage=0;
            }
            else if( $this->up==0 ) $fatherMessage=0;
            if( !$fatherMessage )
            {
            }    
        }
        return ok;
    }
    function showHtmlKeywords(&$s)
    {    
        global $zorumroll;
        $ret = $this->cacheFatherObjects("topic");
        if ($ret!=ok) {
            return $ret;
        }        
        global $fatherTopic;
        if( $zorumroll->class=="forummessage" || $zorumroll->class=="portal" )
        {
            $ret = $fatherTopic->showHtmlKeywords($s);
        }
        else $ret = Object::showHtmlKeywords($s);    
        return $ret;
    } 
    function showHtmlDescription(&$s)
    {
        global $zorumroll;
        $ret = $this->cacheFatherObjects("topic");
        if ($ret!=ok) {
            return $ret;
        }        
        global $fatherTopic;
        if( $zorumroll->class=="forummessage" || $zorumroll->class=="portal" )
        {
            $ret = $fatherTopic->showHtmlDescription($s);
        }
        else $ret = Object::showHtmlDescription($s);    
        return $ret;
    } 
    function showHtmlTitle(&$s)
    {
        global $zorumroll;
        $ret = $this->cacheFatherObjects("topic");
        if ($ret!=ok) {
            return $ret;
        }        
        global $fatherTopic;
        if( $zorumroll->class=="forummessage" || $zorumroll->class=="portal" )
        {
            $ret = $fatherTopic->showHtmlTitle($s);
        }
        else $ret = Object::showHtmlTitle($s);    
        return $ret;
    } 
}
?>
