<?php
$forumtopic_typeInfo =
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "auto increment",
                "form hidden"
            ),
            "pid"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "form hidden",
                "private"
            ),
            "subject"=>array(
                "type"=>"VARCHAR",
                "max" =>"250",
                "min" =>"1",
                "list",
                "not null",
                "sorta"
            ),
            "forumname"=>array(
                "type"=>"VARCHAR",
                "max" =>"120",
                "no column",
                "sorta"
            ),           
            "status"=>array(
                "type"  =>"ENUM",
                "values"=>array( "forum_opened", "forum_closed" ),
                "not null",
                "list",
                "centered",
                "form hidden",
                "private"
            ),           
            "postnum"=>array(
                "type"=>"INT",
                "default" => "0",
                "unsigned",
                "not null",
                "form hidden",
                "list",
                "centered",                
                "sortd",
                "private"
            ),
            "viewnum"=>array(
                "type"=>"INT",
                "default" => "0",
                "unsigned",
                "not null",
                "form hidden",
                "list",
                "centered",                
                "sortd",
                "private"
            ),
            "niceurl"=>array(
                "type"=>"VARCHAR",
                "max" =>"250",
                "not null"
            ),
            "wholeniceurl"=>array(
                "type"=>"VARCHAR",
                "max" =>"250",
                "not null",
                "form invisible"
            ),
            "descriptionTxt"=>array(
                "type"=>"TEXT",
                "no column",
                "rows" => 10,
                "cols" => 50,
                "not null"
            ),
            "txt"=>array(
                "type"=>"TEXT",
                "no column",
                "rows" => 10,
                "cols" => 50,
                "not null"
            ),           
            "prio"=>array(
                "type"=>"INT",
                "default" => "100",
                "unsigned",
                "not null",
                "form invisible"
            ),
            "creator"=>array(
                "type"=>"VARCHAR",
                "max" =>"32",
                "list",
                "not null",
                "form hidden",
                "private",
                "sorta"
            ),            
            "creationtime"=>array(
                "type"=>"INT",
                "form invisible",
                "private"
            ),
            "lastpost"=>array(
                "type"=>"INT",
                "form hidden",
                "list",
                "sorta",
                "not null",
                "private"
            ),            
            "subs_topic"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "not null",
                "default"=>"no",
                "no column"
            ),            
            "poll"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "not null",
                "default"=>"no"
            ),            
            "ratenum"=>array(
                "type"=>"INT",
                "default"=>"0",
                "form invisible",
                "private"
            ),            
            "rateavg"=>array(
                "type"=>"FLOAT(2,1)",
                "default"=>"0",
                "form invisible",
                "private"
            ),            
            "rate"=>array(
                "type"=>"FLOAT(2,1)",
                "default"=>"0",
                "list",
                "sorta",
                "no column",
                "private"
            ),            
            "MAX_FILE_SIZE"=>array(
                "type"=>"INT",
                "form hidden",
                "not null",
                "no column"
            ),
            "att_file_upload"=>array(
                "type"=>"VARCHAR",
                "max" =>"250",
                "not null",
                "no column"
            ),            
            "blockPosition"=>array(
                "type"=>"INT",
                "form hidden",
                "not null",
                "private",
                "unsigned"
            ),            
            "ownerId"=>array(
                "type"=>"INT",
                "unsigned",
                "form invisible",
                "private"
            ),
            "htmlTitle"=>array(
                "type"  =>"VARCHAR",
                "not null",
                "max"  =>"255"
            ),
            "htmlKeywords"=>array(
                "type"  =>"VARCHAR",
                "not null",
                "max"  =>"255"
            ),
            "htmlDescription"=>array(
                "type"  =>"VARCHAR",
                "not null",
                "max"  =>"255"
            ),            
            "coding"=>array(
                "type"  =>"ENUM",
                "values"=>array( "HTML", "UBB", "no" ),
                "not null",
                "default"=>"no"
            ),            
            "smiley"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "not null",
                "default"=>"yes"
            ),            
            "displayPeriodStart"=>array(
                "type"  =>"DATE",
                "not null"
            ),            
            "displayPeriodEnd"=>array(
                "type"  =>"DATE",
                "not null"
            ),            
            "displayPeriodStart_day"=>array(
                "type"  =>"INT",
                "no column",
                "form hidden"
            ),            
            "displayPeriodStart_month"=>array(
                "type"  =>"INT",
                "no column",
                "form hidden"
            ),            
            "displayPeriodStart_year"=>array(
                "type"  =>"INT",
                "no column",
                "form hidden"
            ),            
            "displayPeriodEnd_day"=>array(
                "type"  =>"INT",
                "no column",
                "form hidden"
            ),            
            "displayPeriodEnd_month"=>array(
                "type"  =>"INT",
                "no column",
                "form hidden"
            ),            
            "displayPeriodEnd_year"=>array(
                "type"  =>"INT",
                "no column",
                "form hidden"
            )
        ),
        "primary_key"=>array(
            "id"
        ),
        "tableName"=>"forumtopic_zorum",
        "submit"=>array("ok", "cancel", "preview")
    );
class ForumTopic extends Object
{
    function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
    {
        global $zorumrecognised, $zorumauthlevel, $zorumuser,$zorumroll;
        global $generalRight;
        $hasRight = FALSE;
        $generalRight = FALSE;
        $ret = $this->cacheFatherObject();
        if ($ret!=ok) {
            return $ret;
        }        
        global $fatherForum;
        global $readAccessArr;
        if ($fatherForum->readgroup!=0 ) {
            $ret=readAccessForums();
            if( $ret ) {
                return $ret;
            } 
        }
        hasAdminRights($isAdm);
        if (isset($readAccessArr[$fatherForum->id]) ||
            $fatherForum->readgroup==0 || $isAdm)
        {
            $readRight=TRUE;
        }
        else $readRight=FALSE;
        global $writeAccessArr;
        if ($fatherForum->writegroup!=0) {
            $ret=writeAccessForums();
            if( $ret ) {
                return $ret;
            } 
        }
        if (isset($writeAccessArr[$fatherForum->id]) ||
            $fatherForum->writegroup==0 || $isAdm)
        {
            $writeRight=TRUE;
        }
        else $writeRight=FALSE;
        global $topicAccessArr;
        if ($fatherForum->topicgroup!=0 ) {
            $ret=topicAccessForums();
            if( $ret ) {
                return $ret;
            } 
        }
        if ((isset($topicAccessArr[$fatherForum->id]) ||
            $fatherForum->topicgroup==0 || $isAdm) && $writeRight)
        {
            $writeRight=TRUE;
        }
        else $writeRight=FALSE;
        if( $method==Priv_load )
        {
            $hasRight=$readRight;
            $generalRight = TRUE;
        }
        elseif( $zorumauthlevel==Loginlib_NewUser )
        {
            $hasRight=FALSE;
            $generalRight = TRUE;
        }  
        elseif( $zorumauthlevel==Loginlib_GuestLevel && 
                $fatherForum && $fatherForum->allowAnonym=="no" )
        {
            $hasRight=FALSE;
            $generalRight = TRUE;
        }        
        elseif( $zorumauthlevel>Loginlib_GuestLevel && 
                !$zorumrecognised )
        {
            $hasRight=FALSE;
            $generalRight = TRUE;
        }        
        else
        {
            if( $fatherForum && $fatherForum->status=="forum_closed" ) 
            {
                $hasRight=FALSE;
                $generalRight = ($zorumroll->class=="forumtopic");
            }
            elseif( $method==Priv_create )
            {
                $hasRight=$writeRight;
                $generalRight = ($zorumroll->class=="forumtopic");
            }
            elseif( $zorumuser->isAdm=="yes" )
            {
                $hasRight=TRUE;
                $generalRight = ($zorumroll->class=="forumtopic");
            }
            elseif( $zorumuser->isMod=="yes" )
            {
                if( $fatherForum )
                {
                    $moderators = split( ", *", $fatherForum->moderator );
                    if( in_array($zorumuser->name, $moderators) )
                    {
                        $hasRight=TRUE;
                        $generalRight=($zorumroll->class=="forumtopic");
                    }    
                }
            }
            if( !$hasRight && isset($this->ownerId) && 
                $this->ownerId==$zorumuser->id )
            {
                $generalRight = FALSE;
                if ( $this->postnum!="1")
                {
                    $hasRight=FALSE;
                }
                else
                {
                    $hasRight=$writeRight;
                }
            }
        }
        if( !$hasRight && $giveError )
        {
            global $infoText;
            global $errTxt;
            $txt = $errTxt[permission_denied];
            $infoText[] = $txt;
            return permission_denied;
        }
        return ok;
    }
    function create($overrulePrivilege=FALSE)
    {
        return forumtopic_create($this,$overrulePrivilege);
    }
    function modify($whereFields="", $overrulePrivilege=FALSE )
    {
        return forumtopic_modify($this,$whereFields,$overrulePrivilege);
    }
    function delete($whereFields="", $overrulePrivilege=FALSE )
    {
        return forumtopic_delete($this,$whereFields,$overrulePrivilege);
    }
    function showPreview()
    {
        return forumtopic_showPreview($this);
    }    
    function move()
    {
        return forumtopic_move($this);
    }    
    function showNoNewmessHotTopicImage()
    {
        global $langTxt;
        return "<img src='i/hottopic.gif' width='22'".
               " height='14' alt='".$langTxt["nonewmesshot"]."'".
               " title='".$langTxt["nonewmesshot"]."'>";
    }
    function showNoNewmessTopicImage()
    {
        global $langTxt;
        return "<img src='i/nonewmess.gif' width='19'".
               " height='12' alt='".$langTxt["nonewmess"]."'".
               " title='".$langTxt["nonewmess"]."'>";
    }
    function showNewmessTopicImage()
    {
        global $langTxt;
        return "<img src='i/newmessforum.gif' width='19'".
               " height='19' alt='".$langTxt["newmess"]."'".
               " title='".$langTxt["newmess"]."'>";
    }
    function showNewmessHotTopicImage()
    {
        global $langTxt;
        return "<img src='i/hotnewmess.gif' width='33'".
               " height='18' alt='".$langTxt["newmesshot"]."'".
               " title='".$langTxt["newmesshot"]."'>";
    }
    function showClosedTopicImage()
    {
        global $langTxt;
        return "<img src='i/lockfolder.gif' width='25'".
               " height='20' alt='".$langTxt["closedtopic"]."'".
               " title='".$langTxt["closedtopic"]."'>";
    }
    function showNewToolPlusUrl(&$roll)
    {
        $roll->pid = $this->pid;
        return ok;
    }  
    function modifyForm(&$s,$valid=TRUE)
    {
        return forumtopic_modifyForm($this,$s,$valid);
    }
    function modifyFormInvalid(&$s)
    {
        return forumtopic_modifyFormInvalid($this,$s);
    }
    function createForm(&$s,$valid=TRUE)
    {
        return forumtopic_createForm($this,$s,$valid);
    }
    function createFormInvalid(&$s)
    {
        return forumtopic_createFormInvalid($this,$s);
    }
    function generForm(&$s)
    {
        return forumtopic_generForm($this,$s);
    }
    function moveForm(&$s)
    {
        return forumtopic_moveForm($this,$s);
    }
    function cacheFatherObject()
    {
        global $fatherForum;
        if( isset($this->pid) && $this->pid &&
            (!isset($fatherForum) || !$fatherForum ||
            $fatherForum->id!=$this->pid) ) 
        {
            $fatherForum=new Forum;
            $fatherForum->id=$this->pid;
            $ret=load($fatherForum);
            if( $ret==general_mysql_error ) 
            {
                return $ret;
            }
            else if( $ret==not_found_in_db ) $fatherForum=0;
        }
        else if( !isset($this->pid) || !$this->pid ) $fatherForum=0;
        if( !$fatherForum )
        {
        }    
        return ok;
    }
    function loadHtmlList(&$list)
    {
        return forumtopic_loadHtmlList($this,$list);
    } 
    function showHtmlList(&$s)
    {
        return forumtopic_showHtmlList($this,$s);
    } 
    function showNavBar(&$s, $withLink=FALSE)
    {
        return forumtopic_showNavBar($this,$s, $withLink);
    }
    function showListVal($attr)
    {
        return forumtopic_showListVal($this,$attr);
    }
    function showNewTool(&$s,$rights)
    {
        return forumtopic_showNewTool($this,$s,$rights);
    }
    function showBelowList(&$s)
    {
        return forumtopic_showBelowList($this,$s);
    }
    function showJumperTool(&$s)
    {
        return forumtopic_showJumperTool($this,$s);
    }
    function showDetailsMethods()
    {
        return forumtopic_showDetailsMethods($this);
    } 
    function showHtmlKeywords(&$s)
    {    
        global $zorumroll;
        global $showMetaTags;
        $s="";
        if( $showMetaTags=="no" )
        {
            return ok;
        }
        $ret = $this->cacheFatherObject();
        if ($ret!=ok) {
            return $ret;
        }        
        global $fatherForum;
        if( $zorumroll->method=="showhtmllist" && $zorumroll->class=="forumtopic" )
        {
            $ret = $fatherForum->showHtmlKeywords($s);
        }
        elseif( $zorumroll->class=="forumtopic" || $zorumroll->class=="forummessage" || $zorumroll->class=="portal")
        {    
            $ret = ok;
            if( $this->htmlKeywords )
            {
                $s.="<META NAME='keywords' CONTENT='$this->htmlKeywords'>\n";
            }
            else $ret = $fatherForum->showHtmlKeywords($s);
        }
        else $ret = Object::showHtmlKeywords($s);    
        return $ret;
    } 
    function showHtmlDescription(&$s)
    {
        global $zorumroll;
        global $showMetaTags;
        $s="";
        $ret = $this->cacheFatherObject();
        if ($ret!=ok) {
            return $ret;
        }        
        global $fatherForum;
        if( $zorumroll->method=="showhtmllist" && $zorumroll->class=="forumtopic" )
        {
            $ret = $fatherForum->showHtmlDescription($s);
        }
        elseif( $zorumroll->class=="forumtopic" || $zorumroll->class=="forummessage" || $zorumroll->class=="portal")
        {    
            $ret = ok;
            if( $showMetaTags=="no" )
            {
                $firstMessage = new ForumMessage;
                $firstMessage->tid = $this->id;    
                $firstMessage->pid = $this->pid;    
                $firstMessage->up = 0;    
                $ret = load( $firstMessage, array("tid", "pid", "up") );
                if ($ret==general_mysql_error) {
                    return $ret;
                }
                if( $ret==ok && $firstMessage->descriptionTxt )
                {
                    $s.="<META NAME='description' CONTENT='".
                        htmlspecialchars($firstMessage->descriptionTxt).
                        "'>\n";
                }
                elseif( $this->subject )
                {
                    $s.="<META NAME='description' CONTENT='".
                        htmlspecialchars($this->subject)."'>\n";
                }    
                return ok;
            }
            elseif( $this->htmlDescription )
            {
                $s.="<META NAME='description' CONTENT='$this->htmlDescription'>\n";
            }
            else $ret = $fatherForum->showHtmlDescription($s);
        }
        else $ret = Object::showHtmlDescription($s);    
        return $ret;
    } 
    function showHtmlTitle(&$s)
    {
        global $zorumroll;
        global $showMetaTags;
        $s="";
        $ret = $this->cacheFatherObject();
        if ($ret!=ok) {
            return $ret;
        }        
        global $fatherForum;
        if( $zorumroll->method=="showhtmllist" && $zorumroll->class=="forumtopic" )
        {
            $ret = $fatherForum->showHtmlTitle($s);
        }
        elseif( $zorumroll->class=="forumtopic" || $zorumroll->class=="forummessage" || $zorumroll->class=="portal")
        {    
            $ret = ok;
            if( $showMetaTags=="no" )
            {
                if( $this->subject )
                {
                    $s.="<TITLE>".htmlspecialchars($this->subject)."</TITLE>\n";
                }    
                return ok;
            }
            elseif( $this->htmlTitle )
            {
                $s.="<TITLE>$this->htmlTitle</TITLE>\n";
            }
            else $ret = $fatherForum->showHtmlTitle($s);
        }
        else $ret = Object::showHtmlTitle($s);    
        return $ret;
    } 
}
?>
