<?php
function loadHtmlList($base,&$list)
{
    $ret=$base->hasObjectRights($hasRight, Priv_load, TRUE);
    if( $ret ) {
        return $ret;
    }
    $ret=getListQuery($query);
    if ($ret!=ok) 
    {
        return $ret;
    }                   
    $ret = $base->loadObjectsSQL($query,$list, TRUE);
    $noErr = $ret==ok || $ret==not_found_in_db;
    if ($ret!=ok) 
    {
        return $ret;
    }   
    global $maxdepth;                
    $maxdepth=0;
    if(isTreeView()) 
    {
        foreach($list as $obj) 
        {
            if( $obj->treedepth > $maxdepth ) $maxdepth=$obj->treedepth;
        }
    }
    return ok;
}
function showHtmlList($base,&$s)
{
    global $iconBlankSize;
    global $zorumuser,$zorumroll;
    global $langTxt;
    global $searchEngine;
    $s="";
    $ret = $base->loadHtmlList($list);
    if ($ret==permission_denied) {
        return ok;
    }
    if ($ret!=ok&&$ret!=not_found_in_db) {
        return $ret;
    }
    $class=$base->getClass();
    $ret=$base->hasGeneralRights($rights);
    if ($ret!=ok) {
        return $ret;
    }
    $s.="<table border='0' width='100%' cellpadding='0'".
        " cellspacing='0'>\n";
    $s.="<tr><td align='left'>";
    $ret=$base->showNavBar($s1);
    if ($ret!=ok) {
        return $ret;
    }
    $s.=$s1;
    $s.="</td>\n";
    global $fatherTopic, $fatherForum;
    if( $zorumroll->class=="forummessage" ) {
        $ret = $base->cacheFatherObjects("topic", "forum");
        if ($ret!=ok) {
            return $ret;
        }        
        $s.="<td align='right'>";
        $ret=showViewChange($s1,"","");
        if ($ret!=ok) {
            return $ret;
        }
        $s.=$s1;
        $s.="</td>\n";
        if ($searchEngine=="yes") {
            if( $fatherForum->readgroup==0 )
            {
                global $specBlockSize;
                $b=ceil($fatherTopic->postnum / $specBlockSize)-1;
                $s.="<td align='right'>";
                $s.="<a class='navBar' href='html/".$fatherTopic->id.
                    "_message_$b.html'>".
                    $langTxt["snap_forum"]."</a>";
                $s.="</td>\n";
            }
            else
            {
                $s.="<td align='right'>";
                $s.="<a class='navBar' href='html/forum.html'>".
                    $langTxt["snap_forum"]."</a>";
                $s.="</td>\n";
            }
        }
    }
    elseif( $zorumroll->class=="forum" && $searchEngine=="yes") {
        $s.="<td align='right'>";
        $s.="<a class='navBar' href='html/forum.html'>".
            $langTxt["snap_forum"]."</a>";
        $s.="</td>\n";
    }
    elseif( $zorumroll->class=="forumtopic" && $searchEngine=="yes") {
        $ret = $base->cacheFatherObject();
        if ($ret!=ok) {
            return $ret;
        }        
        if( $fatherForum->readgroup==0 )
        {
            $s.="<td align='right'>";
            $s.="<a class='navBar' href='html/".
                $base->pid."_hottopic.html'>".
                $langTxt["snap_forum"]."</a>";
            $s.="</td>\n";
        }
        else
        {
            $s.="<td align='right'>";
            $s.="<a class='navBar' href='html/forum.html'>".
                $langTxt["snap_forum"]."</a>";
            $s.="</td>\n";
        }
    }
    $s.="</tr></table>\n";
    $s.="<p>";
    if( $zorumroll->class=="forummessage" &&
        $fatherTopic && $fatherTopic->poll=="yes")
    {
        $po = new Poll;
        $po->tid=$fatherTopic->id;
        $ret=load($po,array("tid"));
        if ($ret!=ok && $ret!=not_found_in_db) {
            return $ret;
        }
        if ($ret==ok) {
            global $subsInfo,$zorumrecognised, $zorumauthlevel;
            if (isset($subsInfo["poll_vote"][$po->id]) ||
                !($zorumrecognised || 
                  $zorumauthlevel==Loginlib_GuestLevel)
               )
            {
                $ret=$po->showOnlyPoll($s1);
                if ($ret!=ok && $ret!=not_found_in_db) {
                    return $ret;
                }
            }
            else {
                $ret=$po->voteOnlyForm($s1);
                if ($ret!=ok && $ret!=not_found_in_db) {
                    return $ret;
                }
            }
            $s.=$s1."\n<p>";
        }
    }    
    $ret=$base->showNewTool($newToolText, $rights);
    if ($ret!=ok) {
        return $ret;
    }
    $rangeSelText = showRangeSelector($base);    
    if( $newToolText || $rangeSelText )
    {
         $s.="<table border='0' width='100%'><tr>\n";
         if( $newToolText )
         {
             $s.="<td align='left'>";
             $s.=$newToolText;
             $s.="</td>\n";
         }   
         if( $rangeSelText )
         {
             $s.="<td align='right'>";
             $s.=$rangeSelText;
             $s.="</td>\n";
         }   
         $s.="</tr></table>\n";
         $s.="\n";
    }
    $s.="<table border='0' width='100%' cellpadding='0'".
        " cellspacing='0'><tr><td class='table'>\n";
    $s.="<table border='0' width='100%' cellpadding='2' ".
        "cellspacing='1'>\n";
    $s.= $base->showListHeader();  
    for($i=0;isset($list[$i]);$i++) {
        $ret=$list[$i]->showOneRow($rights,$s1);
        if ($ret!=ok) {
            return $ret;
        }
        $s.=$s1;
    }
    $s.="</table>\n";
    $s.="</td></tr></table>\n";
    $s.="<br>";
    if (!isset($list[0])) {
        $s.="<center><span class='listItem'>".$langTxt["emptylist"]."</span></center><p>";
    }
    if( $newToolText || $rangeSelText )
    {
         $s.="<table border='0' width='100%'><tr>\n";
         if( $newToolText )
         {
             $s.="<td align='left'>";
             $s.=$newToolText;
             $s.="</td>\n";
         }   
         if( $rangeSelText )
         {
             $s.="<td align='right'>";
             $s.=$rangeSelText;
             $s.="</td>\n";
         }   
         $s.="</tr></table>\n";
         $s.="\n";
    }
    $ret=$base->showBelowList($s1);
    if ($ret!=ok) {
        return $ret;
    }
    if( $s1 ) $s.="<br>$s1";
    $ret=$base->showJumperTool($s1);
    if ($ret!=ok) {
        return $ret;
    }
    if( $s1 ) $s.="<br>$s1";
    return ok;
}
function showOneRow($base,$rights,&$s,$tdClass="forumrow")
{
    global $zorumroll;
    $s="<tr class='forumrow'>";
    $typ=$base->getTypeInfo();
    if( !in_array("notools", $typ) )
    {
        $ret=$base->showTools($rights,$s1);
        if ($ret!=ok) {
            return $ret;
        }
        $s.="<td class='$tdClass' valign='top' nowrap>";
        $s.=$s1;
        $s.="</td>\n";
    }    
    $s.=$base->showListEntry($rights);
    $s.="</tr>\n";
    return ok;
}
function showListHeader($base, $isEmpty=FALSE)
{
    global $langTxt;
    global $maxdepth;
    global $zorumroll;
    $typ=$base->getTypeInfo();
    $attrs=$typ["attributes"];
    $className = $base->getClass();
    $s="";
    $s.="<tr class='headerbg'>";
    if( !in_array("notools", $typ) )
    {
        $s.="<th>&nbsp;</th>\n";
    }    
    $first=TRUE;
    foreach( $attrs as $attr=>$val ) {
        if (in_array("list",$val)) {
            $s.="<th nowrap";
            if( isTreeView() && $first && !$isEmpty ) 
            {
                $csp = $maxdepth + 1;
                $s.=" colspan='$csp'";
                $first = FALSE;
            }
            $s.=">";
            $s.="<span class='header'>";
            if (isset($langTxt[$className."_".$attr])) {
                $s.=$langTxt[$className."_".$attr];
            }
            else $s.=$langTxt[$attr];
            $s.="</span>";
            $s.=$base->showSortTool($attr);
            $s.="</th>\n";
        }
    }        
    $s.="</tr>\n";
    return $s;
}
function showListEntry($base, $rights)
{
    global $langTxt;
    global $maxdepth;
    $typ=$base->getTypeInfo();
    $attrs=$typ["attributes"];
    $s="";
    $className = $base->getClass();
    $treeView = isTreeView();
    $modulus=5;
    if ($treeView) {
        for($i=0;$i<$base->treedepth;$i++) {
            $j=$i % $modulus;
            $s.="<td class='forumrow$j' width='1'>";
            $s.="<img src='i/b.gif' width='10'>";
            $s.="</td>\n";
        }
    }
    $q=0;
    foreach( $attrs as $attr=>$val ) {
        if (in_array("list",$val)) {
            if ($treeView) {
                $c=$base->treedepth % $modulus;
                $s.="<td class='forumrow$c'";
            }
            else $s.="<td class='forumrow'";
            if ($treeView && $q==0) {
                $csp = $maxdepth + 1 - $base->treedepth;
                if ($csp>1) $s.=" colspan='$csp'";
            }
            if (in_array("centered",$val)) $s.=" align='center'";
            $s.=">";
            $s1=$base->showListVal($attr, $rights);
            if ($s1=="") $s.="&nbsp;";
            else $s.=$s1;
            $s.="</td>\n";
            $q++;
        }
    } 
    return $s;
}
function isTreeView()
{
    global $zorumroll;
    global $messageView;
    global $forumView;
    $ret = ( ($messageView=="tree" &&
             $zorumroll->class=="forummessage" ) ||
             ($zorumroll->class=="forum")&&($forumView=="tree"));
    return $ret;
}
?>
