<?php
$langTxt["gettingstarted"]="Getting Started";
$langTxt["whoyouare"]="Who you are:";
$langTxt["youhaveloggedinas"]="You have logged in as %s.";
$langTxt["youareadministrator"]="You are an administrator.";
$langTxt["youaremoderator"]="You are a moderator.";
$langTxt["whatyoucando"]="What you can do now:";
$langTxt["showsettings1"]="Clicking on </span><span class='command'>Forum home</span><span class='listItem'>, you can start instantly browsing between the forums, topics and messages.";
$langTxt["showsettings2"]="You can post new topics and messages";
$langTxt["showsettings23"]="You can use also HTML-code in your messages.";
$langTxt["showsettings3"]="You can use also BB-code in your messages.";
$langTxt["showsettings4"]="You can attach files to your messages. The maximum attach size is %s bytes. ";
$langTxt["showsettings5"]="The following extensions are allowed: %s";
$langTxt["showsettings6"]="The following extensions are forbidden: %s";
$langTxt["showsettings7"]="You have eight different subscription possibilities. You can make subscriptions from the </span><span class='command'>Details</span><span class='listItem'> page of the messages, topics, forums and users. You can view your current subscriptions under </span><span class='command'>User functions/Subscriptions</span><span class='listItem'>.";
$langTxt["showsettings8"]="You can add users, forums and topics to your favourities lists from their </span><span class='command'>Details</span><span class='listItem'> page. You can view your favourities list under </span><span class='command'>User functions/Favourities</span><span class='listItem'>.";
$langTxt["showsettings9"]="You can rate topics, messages and users from their </span><span class='command'>Details</span><span class='listItem'> page.";
$langTxt["showsettings10"]="You can personalize the forum behaviour and outlook under </span><span class='command'>User functions/Personalize</span><span class='listItem'>.";
$langTxt["showsettings11"]="You can change your password and modify your user profile at any time.";
$langTxt["showsettings12"]="You can view the list of registered users and their profile.";
$langTxt["showsettings13"]="You can create your own color and font styles.";
$langTxt["asanadministrator"]="As an administrator, you have the following additional possibilities:";
$langTxt["asamoderator"]="As a moderator, you have the following additional possibilities:";
$langTxt["showsettings15"]="You have full write permission to the whole system - you can create, delete or lock forums, modify or delete any topics or messages.";
$langTxt["showsettings16"]="You can add a tree-hierarchy to your forums with the </span><span class='command'>Forum organizer</span><span class='listItem'>.";
$langTxt["showsettings17"]="You can block the unwanted users.";
$langTxt["showsettings18"]="You can set the default behaviour and outlook of the forum under </span><span class='command'>Admin functions/Global settings</span><span class='listItem'>.";
$langTxt["showsettings19"]="You can integrate the forum in your existing site structure and outlook if you define an upper and lower template under </span><span class='command'>Global settings</span><span class='listItem'> and create or change the font and color styles under </span><span class='command'>Style menu</span>.<span class='listItem'>";
$langTxt["showsettings20"]="You can add moderators to the forums.";
$langTxt["showsettings21"]="You have full write permission in the forums you moderate.";
$langTxt["showsettings22"]="You can delete or modify there any topics or messages (not only your own).";
$langTxt["formoredetails"]="For more details, see the <a href='http:/"."/www.zorum.com/documentation' target='new'>Zorum Documentation</a>!";
$langTxt["showsettings_newuser"]=
"<table border='0' width='100%' cellspacing='0' cellpadding='0'>
<tr><td class='table'>
<table border='0' width='100%' cellspacing='1' cellpadding='2'>
<tr class='headerbg'>
<th align='center'><span class='header'>Getting Started</span></th></tr>
<tr><td class='forumrow'><br>
<h3><span class='listItem'>Who you are:</span></h3>
<ul>
<li><span class='listItem'>You are not identified in the forum.</span></li><p>
<li><span class='listItem'>It seems so that you have disabled the cookies in your browser.</span></li><p>
<li><span class='listItem'>Below is a table with the pros and cons of cookies in our forum:</span></li>
</ul>
<p>
<table align='center' border='0' width='90%' cellspacing='0' cellpadding='0'>
<tr><td class='table'>
<table border='0' width='100%' cellspacing='1' cellpadding='2'>
<tr class='headerbg'>
<th><span class='header'>Without cookies</span></th><th><span class='header'>With cookies</span></th></tr>
<tr>
<td class='forumrow'>
<ul>
<li><span class='listItem'>If you are a registered user, you have to log in each time you
visits the forum.</span></li></ul></td>
<td class='forumrow'>
<ul>
<li><span class='listItem'>Your password can be remembered. You need not log in all the time 
until you use the same browser on the same computer.</span></li></ul></td>
</tr>
<tr>
<td class='forumrow'>
<ul>
<li><span class='listItem'>You can't recognise the messages posted since your last visit.
</span></li></ul></td>
<td class='forumrow'>
<ul>
<li><span class='listItem'>You can distinguish between the read and unread messages. The header
of the messages posted since your last visit have a different style.</span>
<tr>
<td class='forumrow'>&nbsp;</td>
<td class='forumrow'>
<ul>
<li><span class='listItem'>You can use the </span><span class='command'>Mark all read</span> <span class='listItem'>possibility to set all unread 
messages to read if you are only interested in messages coming from
now on.</span>
</li></ul></td>
</tr>
</td></tr></table>
</table>
<p>
<h3><span class='listItem'>What you should do first:</span></h3>
<ul>
<li><span class='listItem'>It is recommended that you switch the cookies to enabled
in your browser.</span></li><p>
<li><span class='listItem'>You should register yourself if you haven't done that yet,
or log in if you are already registered.</span></li><p>
<li><span class='listItem'>Below is a table with the pros and cons of registration in our 
forum (there are only pros, actually):</span></li>
</ul>
<p>
<table align='center' border='0' width='90%' cellspacing='0' cellpadding='0'>
<tr><td class='table'>
<table border='0' width='100%' cellspacing='1' cellpadding='2'>
<tr class='headerbg'>
<th><span class='header'>Without registration</span></th><th><span class='header'>With registration</span></th></tr>
<tr>
<td class='forumrow'>
<ul>
<li><span class='listItem'>You are practically in a read-only mode (if you furthermore
disable the cookies).</span></li></ul></td>
<td class='forumrow'>
<ul>
<li><span class='listItem'>You can read, write, delete and change!</span></li></ul></td>
</tr>
<tr>
<td class='forumrow'>
<ul>
<li><span class='listItem'>You can browse in forums, view the messages, but can't post a new
message.</span>
</li></ul></td>
<td class='forumrow'>
<ul>
<li><span class='listItem'>You can post answers to messages, or create your own topics.</span>
<tr>
<td class='forumrow'><ul>
<li><span class='listItem'>You can sort the lists with different sort criteria
and in different directions. You can view them in different views.
However, you can't store your preferred sort criteria, sorting 
direction, or
view per list. You must set them each time you returns to the forum.</span>
</li></ul></td>
</td>
<td class='forumrow'>
<ul>
<li><span class='listItem'>Your preferred settings will be remembered if you set them in the</span>
<span class='command'>Personalization</span> <span class='listItem'>form.</span>
</li></ul></td>
</tr>
<tr>
<td class='forumrow'><ul>
<li><span class='listItem'>You have to settle for the default forum behaviour,
color and font styles - you can't change them.</span>
</li></ul></td>
</td>
<td class='forumrow'>
<ul>
<li><span class='listItem'>You can personalize the behaviour of the forum, create your own 
color and font style and select from different color skins!</span>
</li></ul></td>
</tr>
<tr>
<td class='forumrow'>&nbsp;
</td>
<td class='forumrow'>
<ul>
<li><span class='listItem'>You can make subscriptions, handle favourities lists, rate other 
users and messages.</span>
</li></ul></td>
</tr>
<tr>
<td class='forumrow'>&nbsp;
</td>
<td class='forumrow'>
<ul>
<li><span class='listItem'>You can be an active member of a forum community.</span>
</li></ul></td>
</tr>
</td></tr></table>
</table>
<p>
<span class='listItem'>For more details, see the </span><a href='http:/"."/www.zorum.com/documentation' target='new'>Zorum Documentation</a>!
<p>
</td></tr></table>
</table>
";
$langTxt["showsettings_guestallowed"]=
"<table border='0' width='100%' cellspacing='0' cellpadding='0'>
<tr><td class='table'>
<table border='0' width='100%' cellspacing='1' cellpadding='2'>
<tr class='headerbg'>
<th align='center'><span class='header'>Getting Started</span></th></tr>
<tr><td class='forumrow'><br>
<h3><span class='listItem'>Who you are:</span></h3>
<ul>
<li><span class='listItem'>You are not identified in the forum. You are a guest.</span></li><p>
<li><span class='listItem'>You are not registered, or you are registered but:</span>
<ul>
<li><span class='listItem'>you have logged out, or</span></li>
<li><span class='listItem'>you use an other computer or an other browser than the last time.</span>
</li>
</ul>
</ul>
<p>
<h3><span class='listItem'>What you should do first:</span></h3>
<ul>
<li><span class='listItem'>You should register yourself if you haven't done that yet,
or log in if you are already registered.</span></li><p>
<li><span class='listItem'>Of course, you can use the forum furthermore as a guest.</span></li><p>
<li><span class='listItem'>Below is a table with the pros and cons of registration in our 
forum (there are only pros, actually):</span></li>
</ul>
<p>
<table align='center' border='0' width='90%' cellspacing='0' cellpadding='0'>
<tr><td class='table'>
<table border='0' width='100%' cellspacing='1' cellpadding='2'>
<tr class='headerbg'>
<th><span class='header'>Without registration</span></th><th><span class='header'>With registration</span></th></tr>
<tr>
<td class='forumrow'>
<ul>
<li><span class='listItem'>You can post only anonymous messages and only in forums where the anymous posting is allowed.</span></li></ul></td>
<td class='forumrow'>
<ul>
<li><span class='listItem'>Your user name will be displayed showing that you are the author
of your messages and topics. Other user can send you an email (if
you set your email address to 'visible') and list all the messages and
topics posted by you.</span>
<tr>
<td class='forumrow'><ul>
<li><span class='listItem'>You can personalize the forum behaviour, create your own color and
font styles. However, you can't reach your customizations on an other
computer or with an other browser.</span>
</li></ul></td>
</td>
<td class='forumrow'>
<ul>
<li><span class='listItem'>Your personalizations, styles and favourities list will be coupled
with your user name - you can use them also on an other computer or with
an other browser.</span>
</li></ul></td>
</tr>
<tr>
<td class='forumrow'><ul>
<li><span class='listItem'>You have to visit the forum regularly, if you want to know about
the new messages.</span>
</li></ul></td>
</td>
<td class='forumrow'>
<ul>
<li><span class='listItem'>You can subscribe to new messages, new messages of a forum, of a 
user and many more! You will be instantly informed about the new posts 
of your interest per mail.</span>
</li></ul></td>
</tr>
</td></tr></table>
</table>
<p>
<span class='listItem'>For more details, see the </span><a href='http:/"."/www.zorum.com/documentation' target='new'>Zorum Documentation</a>!
<p>
</td></tr></table>
</table>
";
$langTxt["showsettings_notrecognized"]=
"<table border='0' width='100%%' cellspacing='0' cellpadding='0'>
<tr><td class='table'>
<table border='0' width='100%%' cellspacing='1' cellpadding='2'>
<tr class='headerbg'>
<th align='center'><span class='header'>Getting Started</span></th></tr>
<tr><td class='forumrow'><br>
<h3><span class='listItem'>Who you are:</span></h3>
<ul>
<li><span class='listItem'>You are a registered user.</span></li><p>
<li><span class='listItem'>You are identified as %s.</span></li><p>
<li><span class='listItem'>You have not logged in yet</span></li>
</ul>
<p>
<h3><span class='listItem'>What you should do first:</span></h3>
<ul>
<li><span class='listItem'>If you are not %s, and want to use the forum as a guest, click on</span>
<span class='command'>Logout</span><span class='listItem'>!</span></li><p>
<li><span class='listItem'>If you are not %s, and want to use the forum under an other user name, click on</span>
<span class='command'>Login</span><span class='listItem'>!</span></li><p>
<li><span class='listItem'>If you are really %s, you should log in first.</span></li><p>
<li><span class='listItem'>Of course, you can use the forum furthermore without login, but only
in a read-only mode.</span></li><p>
<li><span class='listItem'>If you check the 'Remember password' option in the login form,
you don't have to log in the next time you visit the forum (until you
use the same browser on the same computer).</span></li><p>
<li><span class='listItem'>You can set the same option also after the login in the </span>
<span class='command'>Personalization</span> <span class='listItem'>form if you select 'Default level' at the 
'Necessary authentication level for write permission' field.</span></li>
</ul>
<p>
<span class='listItem'>For more details, see the </span><a href='http:/"."/www.zorum.com/documentation' target='new'>Zorum Documentation</a>!
<p>
</td></tr></table>
</table>
";
$langTxt["showsettings_notrecognizedhigh"]=
"<table border='0' width='100%%' cellspacing='0' cellpadding='0'>
<tr><td class='table'>
<table border='0' width='100%%' cellspacing='1' cellpadding='2'>
<tr class='headerbg'>
<th align='center'><span class='header'>Getting Started</span></th></tr>
<tr><td class='forumrow'><br>
<h3><span class='listItem'>Who you are:</span></h3>
<ul>
<li><span class='listItem'>You are a registered user.</span></li><p>
<li><span class='listItem'>You are identified as %s.</span></li><p>
<li><span class='listItem'>You have just set the 'Necessary authentication level for write 
permission'
option from 'Advanced' to 'High' in the </span><span class='command'>Personalization</span><span class='listItem'> form.</span>
</ul>
<p>
<h3><span class='listItem'>What you should do first:</span></h3>
<ul>
<li><span class='listItem'>You should log in first. Without login, you can use the forum
only in  a read-only mode.</span></li><p>
</ul>
<p>
<span class='listItem'>For more details, see the </span><a href='http:/"."/www.zorum.com/documentation' target='new'>Zorum Documentation</a>!
<p>
</td></tr></table>
</table>
";
?>
