<?php
define( "Loginlib_NewUser", 1 );
define( "Loginlib_GuestLevel", 2 );
define( "Loginlib_BasicLevel", 3 );
define( "Loginlib_LowLevel", 4 );
define( "Loginlib_HighLevel", 5 );
define( "Loginlib_RemoteHighLevel", 6 );
define( "Loginlib_ExpirationDate", 2000000000 );
function authenticate()
{
    global $PHP_AUTH_USER;
    global $REMOTE_USER;
    global $REMOTE_PASSWORD;
    global $Loginlib_SessionUserId;
    global $Loginlib_GlobalUserId;
    global $Loginlib_Password;
    global $errTxt;
    global $zorumuser;
    global $zorumauthlevel;
    global $u;
    global $zorumlog;
    global $Loginlib_ServerName;
    global $Loginlib_DirectoryName;
    global $x;  
    $x=uniqid("");
    if( !isset($Loginlib_ServerName) ) $Loginlib_ServerName="";
    if( !isset($Loginlib_DirectoryName) ) $Loginlib_DirectoryName="/";
    $zorumlog->userstat="0";
    if( isset($REMOTE_USER) && $REMOTE_USER!="" )
    {
        $zorumauthlevel = Loginlib_RemoteHighLevel;
        $zorumuser = new User;
        $zorumuser->name = $REMOTE_USER;
        $ret = load($zorumuser, array("name"));
        if( $ret==not_found_in_db )
        {
            $zorumuser->init(array( "name"=>$zorumuser->name, 
                                    "password"=>getPassword($REMOTE_PASSWORD) ));
            $ret = create( $zorumuser );
            $ret = load($zorumuser, array("name"));
            $zorumlog->userstat="0";
            return $ret;
        }
        return $ret;
    }
    if( isset($PHP_AUTH_USER) )
    {
        $zorumlog->userstat="1";
        $zorumauthlevel = Loginlib_HighLevel;
        $zorumuser = new User;
        $zorumuser->name = $PHP_AUTH_USER;
        $ret = load($zorumuser, array("name"));
        if( $ret==ok )
        {
            return ok;
        }
    }
    if( isset($Loginlib_SessionUserId) )
    {
        $zorumuser = new User;
        $zorumuser->id = $Loginlib_SessionUserId;
        $ret = load($zorumuser);
        if( $ret==ok )
        {
            if( isset($Loginlib_Password) && 
                $zorumuser->password == $Loginlib_Password)
            {    
                $zorumauthlevel = Loginlib_LowLevel;
                $zorumlog->userstat="1";
                return ok;
            }
            else
            {
            }
        }
        if( $ret==general_mysql_error )
        {
            return $ret;
        }
    }
    if( isset($Loginlib_GlobalUserId) )
    {
        $zorumuser = new User;
        $zorumuser->id = $Loginlib_GlobalUserId;
        $ret = load($zorumuser);
        if( $ret==ok )
        {
            if( $zorumuser->id==$zorumuser->name || 
                isset($Loginlib_Password) && 
                $zorumuser->password == $Loginlib_Password)
            {    
                if( $zorumuser->id==$zorumuser->name )
                {
                    $zorumauthlevel = Loginlib_GuestLevel;
                }
                else    
                {
                    $zorumauthlevel = Loginlib_BasicLevel;
                }
                $zorumlog->userstat="1";
                return ok;
            }
        }
        if( $ret==not_found_in_db )  
        {
            $zorumauthlevel = Loginlib_GuestLevel;
            $zorumuser->init(array("id"=>$zorumuser->id, 
                                   "name"=>$zorumuser->id));
            $ret = create($zorumuser);
            if( $ret!=ok )  
            {
                return $ret;
            }
            $ret = load($zorumuser);
            $zorumlog->userstat="0";
            if( isset($Loginlib_Password) )
            {
                setcookie("Loginlib_Password","",
                          Loginlib_ExpirationDate,$Loginlib_DirectoryName, 
                          $Loginlib_ServerName );    
            }
            return $ret;
        }
        if( $ret!=ok )  
        {
            return $ret;
        }
    }
    if( isset($u) && $u )
    {
        $zorumauthlevel = Loginlib_NewUser;
        $zorumuser = new User;
        $zorumuser->id = $u;
        $ret = load($zorumuser);
        if( $ret==not_found_in_db )  
        {
            $zorumuser->isAdm = "no";
            $zorumuser->isMod = "no";
            $zorumuser->name = $u;
        }
        elseif( $ret==general_mysql_error )
        {
            return $ret;
        }
        if( !isset($zorumuser->isAdm) ) $zorumuser->isAdm = "no";
        if( !isset($zorumuser->isMod) ) $zorumuser->isMod = "no";
        return ok;
    }
    global $Loginlib_TimeOut;
    if( isset($Loginlib_TimeOut) ) $zorumauthlevel=Loginlib_GuestLevel;  
    else $zorumauthlevel = Loginlib_NewUser;   
    $ret = generateRandomId( $randomId );
    if( $ret ) 
    {
        return $ret;
    }
    $u = $randomId;
    $zorumuser = new User;
    $zorumuser->isAdm = "no";
    $zorumuser->isMod = "no";
    $zorumuser->id = $u;
    $zorumuser->name = $u;
    setcookie("Loginlib_GlobalUserId",$randomId,Loginlib_ExpirationDate,
              $Loginlib_DirectoryName, $Loginlib_ServerName );    
}
function createFirstAdmin()
{
    global $zorumauthlevel, $zorumuser;
    global $zorumlog;
    global $Loginlib_GlobalUserId;
    global $Loginlib_DirectoryName;
    global $Loginlib_ServerName;
    global $zorumrecognised;
    $zorumauthlevel = Loginlib_LowLevel;
    $zorumrecognised = TRUE;
    $zorumuser = new User;
    $zorumuser->id = $Loginlib_GlobalUserId;
    $zorumuser->name = "admin";
    $zorumuser->password = getPassword("admin");
    $zorumuser->isAdm = "yes";
    $ret = create($zorumuser);
    if( $ret!=ok )  
    {
        return $ret;
    }
    $ret = load($zorumuser);
    if( $ret!=ok )  
    {
        return $ret;
    }
    $zorumlog->userstat="0";
    if( !isset($Loginlib_ServerName) ) $Loginlib_ServerName="";
    if( !isset($Loginlib_DirectoryName) ) $Loginlib_DirectoryName="/";
    setcookie("Loginlib_Password",$zorumuser->password,
              Loginlib_ExpirationDate,$Loginlib_DirectoryName, 
              $Loginlib_ServerName );    
    return ok;
}
function generateRandomId( &$id ,$class="user")
{
    $user = new $class;
    mt_srand((double)microtime()*1000000);
    do
    {
        $id = (int)mt_rand();
        $user->id = $id;
        $ret = load($user);
        if( $ret==general_mysql_error )
        {
            return $ret;
        }
    }
    while( !$ret );
    return ok;
}
?>
