<?php 
function portalMain(&$s)
{
    global $infoText;
    global $langTxt;
    global $pageForwarder;
    $s="";
    getSystemGlobals();
    $ret = portalMainMain($s1, $htmlHeader);
    if( $ret )
    {   
        $infoText[]=$langTxt["generalErrorMessage"];
        $s=showInfoText();
    }    
    if( !isset($pageForwarder) )
    {
        global $upperTemplate;
        if (ereg("\.php$",$upperTemplate)) {
            $ret=@include($upperTemplate);
            if (!$ret) {
                $infoText[] = sprintf($langTxt["incl_header_err"],
                                $upperTemplate);
                $s.=showInfoText(TRUE);
            }
        }
        else $s.=$upperTemplate;
    }
    $s.=$s1;
    if( !isset($pageForwarder) )
    {
        global $lowerTemplate;
        if (ereg("\.php$",$lowerTemplate)) {
            $ret=@fopen($lowerTemplate,"r");
            if (!$ret) {
                $infoText[]=sprintf($langTxt["incl_footer_err"],
                                    $lowerTemplate);
                $s.=showInfoText(TRUE);
            }
        }
        global $lowerTemplate;
        if (ereg("\.php$",$lowerTemplate)) $ret=@include($lowerTemplate);
        else $s.=$lowerTemplate;
    }
    if( $htmlHeader ) $s = "$htmlHeader$s";
}
function portalMainMain(&$s, &$htmlHeader)
{
    global $zorumroll,$langTxt;
    global $whatHappened;
    global $infoText;
    $ret = initializeSystemSettings();    
    if ($ret)
    {
        return $ret;
    }
    $sw= new Stopwatch();
    $sw->start();
    if (!$zorumroll->class) $zorumroll->class="portal";
    if (!$zorumroll->method) $zorumroll->method="catnews";
    if (!$zorumroll->scriptname) $zorumroll->scriptname="portal.php";
    $whatHappened="";
    if( $zorumroll->inf ) 
    {
        $infoText = array();
        $infoText[]=$zorumroll->inf;
        $zorumroll->inf = "";
    }    
    $ret=loadActiveObjects();
    if ($ret!=ok) {
        return $ret;
    }
    $s="";
    $ret = loadStyleHeader();
    if ($ret) {
        return $ret;
    }
    $ret = initializeThemes();
    if ($ret) {
        return $ret;
    }
    $ret = showStyleHeader($s1);
    if ($ret) {
        return $ret;
    }
    $s.=$s1;
    $ret = showPortalHeader($leftHeader, "left");
    if ($ret) {
        return $ret;
    }
    $ret = showPortalHeader($rightHeader, "right");
    if ($ret) {
        return $ret;
    }
    $base = new $zorumroll->class;    
    $ret = processMethod($base, $processResult);
    if ($ret){
        return $ret;
    }
    if( $whatHappened ) 
    {
        $s = generPageForwarder();
        return ok;
    }
    $s.=showPortal( $leftHeader, $processResult, $rightHeader );
    $ret=showHtmlHeader($htmlHeader);
    if ($ret!=ok) {
        return $ret;
    }
    $s.= showPFooter();
    $sw->stop();
    return ok;
}
function showHtmlHeader(&$s)
{
    global $activeMessage, $activeForum;
    if( $activeMessage ) $ret = $activeMessage->showHtmlHeader($s);
    elseif( $activeForum ) $ret = $activeForum->showHtmlHeader($s);
    else
    {
        $object = new Object;
        $ret = $object->showHtmlHeader($s);
    }
    return $ret;
}
class Portal
{
    function getTypeInfo()
    {
        return 0;
    }
}
function initializeThemes()
{
    global $sourceDir;
    global $activeTheme,$zorumSkin;
    global $portalLeftWidth,$portalLeftBgImg,$portalLeftBgCol;
    global $portalMiddleWidth,$portalMiddleBgImg,$portalMiddleBgCol;    
    global $portalRightWidth,$portalRightBgImg,$portalRightBgCol;
    global $pollLineBg, $pollCellBg, $pollStrongerBg;
    global $iP;
    global $bodyBgImg;    
    global $dotDot;
    if (!isset($dotDot)) $dotDot=".";
    include("$sourceDir/themes/$activeTheme/theme.php");
    return ok;     
}
?>
