<?php
$roll_typeInfo =  
    array(
        "attributes"=>array(   
            "method"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "scriptname"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "class"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "rollid"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "fromclass"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "frommethod"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "fromscriptname"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "fromid"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "menu"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "rangeoffset"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "offset"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "usersorta"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "usersortd"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "stylesorta"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "stylesortd"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "ubbhandlersorta"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "ubbhandlersortd"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "pollsorta"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "pollsortd"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "boxsorta"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "boxsortd"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "groupsorta"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "groupsortd"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "blacklistsorta"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "blacklistsortd"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "forumsorta"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "forumsortd"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "forummessagesorta"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "forummessagesortd"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "forumtopicsorta"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "forumtopicsortd"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "inf"=>array(
                "type"=>"VARCHAR",
                "not null"
            ),
            "firstcall"=>array(
                "type"=>"VARCHAR",
                "not null"
            )              
        )
    );
class Roll extends Object
{
    function create()
    {
        global $zorumuser, $zorumauthlevel;
        $typ = $this->getTypeInfo();
        foreach( array_keys($typ["attributes"]) as $attribute )
        {
            global $$attribute;
            if( isset($$attribute) ) 
            {
                $this->{$attribute} = $$attribute;
            } 
            else $this->{$attribute} = "";   
        }
    }
    function unsetAttrs( $whatFields )
    {
        $whatFields=split( ", *", $whatFields );
        $typ = $this->getTypeInfo();
        foreach( array_keys($typ["attributes"]) as $attribute )
        {
            if( in_array($attribute, $whatFields) )
            {
                $this->{$attribute} = "";
            }
        }
    }
    function makeUrl($type="withScript")
    {
       return roll_makeUrl($this,$type);
    }
    function generHiddenFields()
    {
        global $u;
        $s = "";
        $typ = $this->getTypeInfo();
        $object_vars = get_object_vars($this);
        foreach( $object_vars as $attribute=>$value )
        {
            if( $value && $attribute!="scriptname")
            {
                $s.=generHiddenField($attribute,$value);
            }
        }
        if( $u!="" ) $s.=generHiddenField("u",$u);
        return $s;
    }
    function generAnchor($label,$class="",$withScript=TRUE)
    {
        $type = $withScript ? "withScript" : "";       
        $href=$this->makeUrl($type);
        $s="";
        $s.="<a href='$href'>";
        if ($class) $s.="<span class='$class'>";
        $s.=$label;
        if ($class) $s.="</span>"; 
        $s.="</a>";
        return $s;
    }
    function generImageAnchor($src,$alt,$width="",$height="")
    {
        $label="<img src=\"$src\" alt=\"$alt\" border=\"0\"".
               " title='$alt'";
        if ($width!="") $label.=" width=\"$width\"";
        if ($width!="") $label.=" width=\"$width\"";
        $label.=">";
        return $this->generAnchor($label);
    }
    function generConfirmation($label, $yesButtonLabel="yes",$noButtonLabel="no", $class="forumrow")
    {
        return roll_generConfirmation($this, $label, $yesButtonLabel,$noButtonLabel, $class);
    }
}    
function generHiddenField($name="",$value="")
{
    $value=htmlspecialchars($value);
    if( $name!="" )
    {
        return "\n<input type=\"hidden\" name=\"$name\"".
            " value=\"$value\">\n";
    }
    global $zorumroll;
    return $zorumroll->generHiddenFields();
}
function goBackward( $whatHappened )
{
    global $zorumroll;
    global $infoText;
    global $HTTP_POST_VARS;
    global $roll_typeInfo;
    foreach($HTTP_POST_VARS as $key=>$val) 
    {
        if( $key!="u" && !isset($roll_typeInfo["attributes"][$key])) 
        {
            global $$key;
            if( is_array($val) )
            {
            /*
                foreach( $val as $keykey=>$valval )
                {
                    $zorumroll->{$key}[$keykey]=stripslashes($valval);
                }
                */
            }
            else 
            {
                $zorumroll->{$key}=stripslashes($$key);
            }    
        }    
    }
    if( $whatHappened=="form_submitted" || $whatHappened=="logout" )
    {
        $zorumroll->class = $zorumroll->fromclass;
        $zorumroll->method = $zorumroll->frommethod;
        $zorumroll->rollid = $zorumroll->fromid;
        $zorumroll->scriptname = $zorumroll->fromscriptname;
    }
    elseif( $whatHappened=="reset_form" )
    {
        if ($zorumroll->method!="showpoll" && 
            $zorumroll->method!="showhtmllist")
        {
            $zorumroll->method .= "_form";
        }
        $zorumroll->scriptname = str_replace("_method","_form",$zorumroll->scriptname);
    }
    elseif( $whatHappened=="invalid_form" )
    {
        $zorumroll->method .= "_form_invalid";
        $zorumroll->scriptname = str_replace("_method","_form",$zorumroll->scriptname);
    }
    if( sizeof($infoText)>0 ) 
    {   
        $zorumroll->inf = $infoText[sizeof($infoText)-1];
    }
    return ok;
}
?>
