<?php
    function stylesheet_createForm(&$base, &$s)
    {
        global $infoText;
        global $zorumuser, $zorumfontstylesheet, $zorumcolorstylesheet;
        global $langTxt;
        global $stylesheet_typeInfo;
        $ret = $base->hasObjectRights($hasRight, Priv_create, TRUE);
        if( $ret )
        {
            return $ret;
        }
        if( $base->type=="font" )
        {
            $name = $zorumfontstylesheet->name; 
            $lang = "createFontCssMessage"; 
        }
        else
        {
            $name = $zorumcolorstylesheet->name; 
            $lang = "createColorCssMessage"; 
        }     
        if( sizeof($infoText)==0 )
        { 
           $infoText[]=sprintf($langTxt[$lang],htmlspecialchars($name));
        }   
        if( $base->name=="" ) 
        {
            $base->name = htmlspecialchars($zorumuser->name).
                          "'s style (based on $name)";
        }    
        $attrs = & $stylesheet_typeInfo["attributes"];
        $attrNames = array_keys($stylesheet_typeInfo["attributes"]);
        $attrs["id"][] = "form invisible";
        foreach( $attrNames as $attrName )
        {
            if(in_array("style",$attrs[$attrName]))
            {
                $attrs[$attrName][]="form invisible";
            }    
        }    
        $ret=$base->generForm($s);
        if ($ret!=ok) 
        {
            return $ret;
        }
        return ok;
    }
    function stylesheet_modifyForm(&$base, &$s)
    {
        global $whatHappened, $infoText;
        global $zorumroll, $zorumuser;
        global $langTxt;
        global $zorumfontstylesheet, $zorumcolorstylesheet;
        global $oldmethod, $oldclass, $oldrollid, $oldscriptname;
        global $method, $class, $rollid, $scriptname;
        global $inf;
        $ret = $base->type=="font" ? 
               $zorumfontstylesheet->hasObjectRights($hasRight, Priv_modify, TRUE):
               $zorumcolorstylesheet->hasObjectRights($hasRight, Priv_modify, TRUE);
        if( $ret )
        {
            return $ret;
        }
        $s = "";
        $method = $oldmethod;
        $class  = $oldclass;
        $rollid  = $oldrollid;
        $scriptname  = $oldscriptname;
        $inf = $langTxt["infoText"];
        global $inStyleEditor;
        $inStyleEditor=TRUE;
        $ret = forumMainMain($s1, $htmlHeader);
        if( $ret )
        {   $infoText[]=$langTxt["generalErrorMessage"];
            $s1.=showInfoText();
        }
        $inStyleEditor=FALSE;
        $tempArray = explode( "<!-- Style Editor Content -->", $s1, 3 );
        $s1 = $tempArray[1];    
        global $HTTP_GET_VARS, $HTTP_POST_VARS;
        $tempRoll = new Roll;
        foreach($HTTP_GET_VARS as $key=>$val) 
        {
            if( $key!="x" && $key!="u" ) $tempRoll->{$key}=stripslashes($val);
        }
        foreach($HTTP_POST_VARS as $key=>$val) 
        {
            if( $key!="x" && $key!="u" ) $tempRoll->{$key}=stripslashes($val);
        }
        unset($tempRoll->styleitem);
        $tempRoll->scriptname = "z_stylesheet_form.php";
        if( $base->type=="font" )
        {
            $tempRoll->class="fontstyle";
            $tempRoll->method="modifyfontstyle_form";
        }
        else if( $base->type=="color" )                 
        {
            $tempRoll->class="colorstyle";
            $tempRoll->method="modifycolorstyle_form";
        }
        $url = $tempRoll->makeUrl();
        $search = array ("'<a [^>]*?".">'i",  
                         "'</a>'i",
                         "#<span class='(\w+)'>#i",
                        "'</span>'i"
                        );  
        $replace = array ("",
                        "",
                        "<a href='".$url."styleitem=\\1&' class='nonavstyle'>\\0",
                        "\\0</a>"
                        );
        $s1 = preg_replace ($search, $replace, $s1);
        $infoText = array();
        $zorumroll->method = "modify";
        $zorumroll->class  = "stylesheet";
        $zorumroll->scriptname  = "z_stylesheet_method.php";
        if( $base->type=="font" )
        {
            $label = sprintf($langTxt["modifyFontCssMessage"], 
                         htmlspecialchars($zorumfontstylesheet->name));  
        }
        else if( $base->type=="color" )                 
        {
            $label = sprintf($langTxt["modifyColorCssMessage"], 
                         htmlspecialchars($zorumcolorstylesheet->name));
        }
        $s.=$zorumroll->generConfirmation( $label, 0, "cancel" );
        $s.="<p>";
        $s.="\n<table border='10' width='100%' class='stylebox'><tr><td>\n";
        $s.=$s1;
        $s.="\n</td></tr></table>\n";
        return ok;
    }
?>