<?php
$initSubs=TRUE;
$subscribe_typeInfo = 
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "not null",
                "auto increment",
                "form hidden"
            ),
            "type"=>array(
                "type"=>"INT",
                "not null",
                "form hidden"
            ),            
            "userid"=>array(
                "type"=>"INT",
                "not null",
                "form hidden"
            ),            
            "classid"=>array(
                "type"=>"INT",
                "not null",
                "form hidden"
            ),            
            "sent"=>array(
                "type"=>"INT",
                "not null",
                "form invisible"
            ),
            "email"=>array(
                "type"=>"VARCHAR",
                "max" =>"64",
                "not null",
                "no column"
            ),            
        ),
        "primary_key"=>array("id"),
        "unique_keys"=>array("type,userid,classid"),
        "tableName"=>"subscribe_zorum");
class Subscribe extends Object
{
    function create()
    {
        global $zorumroll,$langTxt,$zorumuser;
        global $whatHappened, $infoText;
        global $subscription,$subsInfo;
        global $zorumrecognised, $zorumauthlevel;
        if ($this->type==poll_vote) 
        {
            $poll = new Poll;
            $poll->id=$this->classid;
            $ret = load($poll);
            if ($ret!=ok) {
                return $ret;
            }
            $ret = $poll->hasObjectRights($hasRight, Priv_insert, TRUE);
            if ($ret!=ok) {
                return $ret;
            }
        }    
        if ($this->type==poll_vote && !$this->sent) {
            if( $zorumroll->class=="forumtopic" )
            {
                $whatHappened = "form_submitted";
            }
            else
            {
                $zorumroll->method = "vote";
                $zorumroll->class = "poll";
                $zorumroll->scriptname = "z_poll_method.php";
                $zorumroll->id = $this->classid;
                $whatHappened = "reset_form";
            }    
            $infoText[] = $langTxt["selectAnOption"];
            return ok;            
        }
        $whatHappened = "form_submitted";
        $this->userid=$zorumuser->id;
        unset($this->id);
        if(!$zorumrecognised && $zorumauthlevel!=Loginlib_GuestLevel) {
            $infoText[] = $langTxt["permission_denied"];
            return nok;            
        }
        $ret=create($this);
        if ($ret==allready_in_db && $this->type>=rate_user &&
            $this->type<=rate_mess)
        {
            $ret=modify($this,array("type","userid","classid"));
        }
        if ($ret!=ok) {
            return $ret;
        }
        if ($this->type>=rate_user && $this->type<=rate_mess) {
            $query="SELECT AVG(sent) AS avg,COUNT(*) AS count".
                   " FROM subscribe_zorum".
                   " WHERE type=$this->type AND classid=$this->classid";
            $result=mysql_query($query);
            if( $result==0 ) {
                return general_mysql_error;
            }
            $row = mysql_fetch_array($result);
            $avg = $row["avg"];
            $count = $row["count"];
            if ($this->type==rate_user) $o = new User;
            elseif ($this->type==rate_topic) $o = new ForumTopic;
            elseif ($this->type==rate_mess) $o = new ForumMessage;
            $o->id=$this->classid;
            $o->ratenum=$count;
            $o->rateavg=$avg;
            $ret=modify($o,"");
            if ($ret!=ok) {
                return $ret;
            }
        }
        if ($this->type==poll_vote) {
            $query="UPDATE poll_zorum SET voted=1".
                   " WHERE id=$this->classid";
            $result=mysql_query($query);
            if( $result==0 ) {
                return general_mysql_error;
            }
            $whatHappened = "reset_form";
            if ($zorumroll->fromclass=="forummessage") {
                $zorumroll->method = "showhtmllist";
                $zorumroll->class = "forummessage";
                $zorumroll->scriptname = "z_forummessage_show.php";
                $zorumroll->rollid = $zorumroll->fromid;
            }
            else {
                $zorumroll->method = "showpoll";
                $zorumroll->class = "poll";
                $zorumroll->scriptname = "z_poll_show.php";
                $zorumroll->id = $this->classid;
            }
        }
        $subscription|=$this->type;    
        if ($this->type==subs_forum_new_mess) {
            $subsInfo["forummess"][$this->classid]=1;
        }
        elseif ($this->type==subs_forum_new_topic) {
            $subsInfo["forumtopic"][$this->classid]=1;
        }
        elseif ($this->type==subs_topic_new_mess) {
            $subsInfo["topics"][$this->classid]=1;
        }
        elseif ($this->type==subs_user_new_mess) {
            $subsInfo["usertomess"][$this->classid]=1;
        }
        elseif ($this->type==subs_user_new_topic) {
            $subsInfo["usertotopic"][$this->classid]=1;
        }
        elseif ($this->type==subs_reply) {
            $subsInfo["reply"][$this->classid]=1;
        }
        elseif ($this->type==fav_user) {
            $subsInfo["favuser"][$this->classid]=1;
        }
        elseif ($this->type==fav_forum) {
            $subsInfo["favforum"][$this->classid]=1;
        }
        elseif ($this->type==fav_topic) {
            $subsInfo["favtopic"][$this->classid]=1;
        }        
        elseif ($this->type==poll_vote) {
            $subsInfo["poll_vote"][$this->classid]=1;
        }        
        if ($this->type>=rate_user) $infoText[] = $langTxt["rate_ok"];
        elseif ($this->type>subs_reply) $infoText[]=$langTxt["fav_ok"];
        else $infoText[] = $langTxt["subs_ok_".$this->type];
        return ok;
    }
    function delete()
    {
        global $zorumroll,$langTxt,$zorumuser;
        global $whatHappened, $infoText;
        global $subscription,$subsInfo;
        global $zorumrecognised, $zorumauthlevel;
        $whatHappened = "form_submitted";
        $this->userid=$zorumuser->id;
        unset($this->id);
        if(!$zorumrecognised && $zorumauthlevel!=Loginlib_GuestLevel) {
            $infoText[] = $langTxt["permission_denied"];
            return nok;            
        }
        $ret=delete($this,array("userid","type","classid"));
        if ($ret!=ok) {
            return $ret;
        }
        $subscription-=$this->type;
        if ($this->type==subs_forum_new_mess) {
            $subsInfo["forummess"][$this->classid]=1;
        }
        elseif ($this->type==subs_forum_new_topic) {
            $subsInfo["forumtopic"][$this->classid]=1;
        }
        elseif ($this->type==subs_topic_new_mess) {
            unset($subsInfo["topics"][$this->classid]);
        }
        elseif ($this->type==subs_user_new_mess) {
            unset($subsInfo["usertomess"][$this->classid]);
        }
        elseif ($this->type==subs_user_new_topic) {
            unset($subsInfo["usertotopic"][$this->classid]);
        }
        elseif ($this->type==subs_reply) {
            unset($subsInfo["reply"][$this->classid]);
        }
        elseif ($this->type==fav_user) {
            unset($subsInfo["favuser"][$this->classid]);
        }
        elseif ($this->type==fav_forum) {
            unset($subsInfo["favforum"][$this->classid]);
        }
        elseif ($this->type==fav_topic) {
            unset($subsInfo["favtopic"][$this->classid]);
        }
        elseif ($this->type==poll_vote) {
            unset($subsInfo["poll_vote"][$this->classid]);
        }        
        if ($this->type>subs_reply) $infoText[] = $langTxt["delfav_ok"];
        else $infoText[] = $langTxt["unsubs_ok"];
        return ok;
    }
    function vote()
    {
        return subscribe_vote($this);
    }
}
function sendMailToSubscribed($forum,$topic,$mess,$user,$which="mess")
{
    global $errTxt,$zorumroll,$zorumuser;
    if ($which=="topic") {
        $order[0]=subs_all_new_topic;
        $order[1]=subs_forum_new_topic;
        $order[2]=subs_user_new_topic;
    }
    else {
        $order[0]=subs_all_new_mess;
        $order[1]=subs_forum_new_mess;
        $order[2]=subs_topic_new_mess;
        $order[3]=subs_user_new_mess;
        $order[4]=subs_reply;
    }
    for($i=0;isset($order[$i]);$i++) {
        if ($order[$i]==subs_user_new_mess ||
            $order[$i]==subs_user_new_topic)
        {
            $whichclass=$user->id;
        }
        elseif ($order[$i]==subs_forum_new_topic||
                $order[$i]==subs_forum_new_mess)
        {
            $whichclass=$forum->id;
        }
        elseif ($order[$i]==subs_topic_new_mess) {
            $whichclass=$topic->id;
        }
        elseif ($order[$i]==subs_reply) {
            $whichclass=$mess->up;
        }
        else $whichclass=0;
        $ret=sendToSubsCategory($order[$i],$whichclass,$forum,$topic,
                                $mess,$user,$sent);
        if ($sent) {
             break;   
        }
    }
    return ok;
}
function sendToSubsCategory($whichtype,$whichclass,$forum,$topic,$mess,$user,&$sent)
{
    global $zorumuser;
    $sub = new Subscribe;
    $query="SELECT type,classid,userid,sent,email".
           " FROM subscribe_zorum s, user_zorum u".
           " WHERE type=$whichtype".
           " AND classid=$whichclass".
           " AND userid=u.id".
           " AND sent=0";
    $ret = $sub->loadObjectsSQL($query,$list, TRUE);
    if ($ret==not_found_in_db) {
        return ok;
    }
    if ($ret!=ok) {
        return $ret;
    }
    $ret=makeMailText($whichtype,$forum,$topic,$mess,$user,$subject,
                      $text);
    if ($ret!=ok) {
        return $ret;
    }
    global $adminEmail;
    if ($adminEmail!="") $from="From: $adminEmail";
    else $from="";
    for($i=0;isset($list[$i]);$i++) {
        if ($list[$i]->type==$whichtype &&
            $list[$i]->sent==0&&$zorumuser->id!=$list[$i]->userid)
        {
            $ret=mail($list[$i]->email,$subject,$text,$from);
        }
    }
    $query="UPDATE subscribe_zorum SET sent=1 WHERE type=$whichtype";
    $result=mysql_query($query);
    if( $result==0 ) {
        $txt = mysql_error();
        $infoText[] = $txt;
        return general_mysql_error;
    }               
    return ok;
}
function makeMailText($whichtype,$forum,$topic,$mess,$user,&$subject,&$text)
{
    global $SCRIPT_NAME,$SERVER_NAME;
    global $infoText,$langTxt;
    $tempRoll = new Roll;
    $tempRoll->method = "showhtmllist";
    $tempRoll->scriptname = "z_forum_show.php";
    $tempRoll->class = "forum";
    $url=$tempRoll->makeUrl("mixed");
    $tempRoll = new Roll;
    $tempRoll->method = "showhtmllist";
    $text="";
    $text.=$langTxt["mail_greet"]."\n\n";
    switch($whichtype) {
        case subs_all_new_mess :
            $subject=$langTxt["mail_subj_subs_all_new_mess"];       
            $text.=sprintf($langTxt["mail_text_subs_all_new_mess"],
                           $url,$forum->name,$topic->subject,
                           $mess->subject,$user->name);
            $tempRoll->scriptname="z_forummessage_show.php";
            $tempRoll->class="forummessage_new";
            $url2=$tempRoll->makeUrl("mixed");
            $text.="\n";
            $text.=sprintf($langTxt["mail_text_url_new_mess"],$url2);
            $text.="\n".$langTxt["mail_subs_all_new_mess_nomore"];
            break;
        case subs_all_new_topic :
            $subject=$langTxt["mail_subj_subs_all_new_topic"];       
            $text.=sprintf($langTxt["mail_text_subs_all_new_topic"],
                           $url,$forum->name,$topic->subject,
                           $mess->subject,$user->name);
            $tempRoll->scriptname="z_forumtopic_show.php";
            $tempRoll->class="forumtopic_newt";
            $url2=$tempRoll->makeUrl("mixed");
            $text.="\n";
            $text.=sprintf($langTxt["mail_text_url_new_topic"],$url2);
            $text.="\n".$langTxt["mail_subs_all_new_topic_nomore"];
            break;
        case subs_forum_new_mess :
            $subject=sprintf($langTxt["mail_subj_subs_forum_new_mess"],
                             $forum->name);
            $text.=sprintf($langTxt["mail_text_subs_forum_new_mess"],
                           $forum->name,$url,$forum->name,
                           $topic->subject,$mess->subject,$user->name);
            $tempRoll->scriptname="z_forummessage_show.php";
            $tempRoll->class="forummessage_new";
            $url2=$tempRoll->makeUrl("mixed");
            $text.="\n";
            $text.=sprintf($langTxt["mail_text_url_new_mess"],$url2);
            $text.="\n".$langTxt["mail_subs_all_new_mess_nomore"];
            break;
        case subs_forum_new_topic :
            $subject=sprintf($langTxt["mail_subj_subs_forum_new_topic"],
                             $forum->name);       
            $text.=sprintf($langTxt["mail_text_subs_forum_new_topic"],
                           $forum->name,$url,$forum->name,
                           $topic->subject,$mess->subject,$user->name);
            $tempRoll->scriptname="z_forumtopic_show.php";
            $tempRoll->class="forumtopic_newt";
            $url2=$tempRoll->makeUrl("mixed");
            $text.="\n";
            $text.=sprintf($langTxt["mail_text_url_new_topic"],$url2);
            $text.="\n".$langTxt["mail_subs_all_new_topic_nomore"];
            break;
        case subs_topic_new_mess :
            $subject=sprintf($langTxt["mail_subj_subs_topic_new_mess"],
                             $topic->subject);
            $text.=sprintf($langTxt["mail_text_subs_topic_new_mess"],
                           $forum->name,$topic->subject,$url,
                           $forum->name,
                           $topic->subject,$mess->subject,$user->name);
            $tempRoll->scriptname="z_forummessage_show.php";
            $tempRoll->class="forummessage";
            $tempRoll->rollid="$forum->id,$topic->id";
            $url2=$tempRoll->makeUrl("mixed");
            $text.="\n";
            $text.=sprintf($langTxt["mail_text_url_new_in_topic"],
                           $url2);
            $text.="\n".$langTxt["mail_subs_all_new_mess_nomore"];
            break;
        case subs_user_new_mess :
            $subject=sprintf($langTxt["mail_subj_subs_user_new_mess"],
                             $user->name);
            $text.=sprintf($langTxt["mail_text_subs_user_new_mess"],
                           $user->name,$url,$forum->name,
                           $topic->subject,$mess->subject,$user->name);
            $tempRoll->scriptname="z_forummessage_show.php";
            $tempRoll->class="forummessage_user";
            $tempRoll->rollid="$user->id,$user->name";
            $url2=$tempRoll->makeUrl("mixed");
            $text.="\n";
            $text.=sprintf($langTxt["mail_text_url_new_mess"],$url2);
            $text.="\n".$langTxt["mail_subs_all_new_mess_nomore"];
            break;
        case subs_user_new_topic :
            $subject=sprintf($langTxt["mail_subj_subs_user_new_topic"],
                             $user->name);       
            $text.=sprintf($langTxt["mail_text_subs_user_new_topic"],
                           $user->name,$url,$forum->name,
                           $topic->subject,$mess->subject,$user->name);
            $tempRoll->scriptname="z_forumtopic_show.php";
            $tempRoll->class="forumtopic_user";
            $tempRoll->rollid="$user->id,$user->name";
            $url2=$tempRoll->makeUrl("mixed");
            $text.="\n";
            $text.=sprintf($langTxt["mail_text_url_new_topic"],$url2);
            $text.="\n".$langTxt["mail_subs_all_new_topic_nomore"];
            break;
        case subs_reply :
            $subject=sprintf($langTxt["mail_subj_subs_reply"],
                             $mess->subject);
            $text.=sprintf($langTxt["mail_text_subs_reply"],
                           $url,$forum->name,
                           $topic->subject,$mess->subject,$user->name);
            $tempRoll->scriptname="z_forummessage_show.php";
            $tempRoll->class="forummessage";
            $tempRoll->rollid="$forum->id,$topic->id";
            $url2=$tempRoll->makeUrl("mixed");
            $text.="\n";
            $text.=sprintf($langTxt["mail_text_url_new_in_topic"],
                           $url2);
            $text.="\n".$langTxt["mail_subs_all_new_mess_nomore"];
            break;
        default:
            return nok;
    }
    return ok;
}
function showUserSubscriptions(&$s,$subs=TRUE)
{
    global $whatHappened,$infoText,$langTxt;
    global $zorumroll; 
    $s="";
    goForward( $tempRoll, "forums" );
    $s.=$tempRoll->generAnchor($langTxt["forums"],"navBar");
    $s.="&nbsp;>&nbsp;";
    if ($subs) $s.=$langTxt["usersubs_title"];
    else $s.=$langTxt["userfav_title"];
    $s.="<p>";    
    $s=insertSpanClass( $s, "navBar" );
    $s.="<table border='0' class='forumrow0' width='100%'><tr><td>";
    if ($subs) $s.=showSubscribe();
    $s.="<table width='100%' border='0'><tr><td valign='top'>";
    $sU = new SubsUserList;
    $ret = $sU->showHtmlList($s1,$subs);
    if ($ret!=ok) {
        return $ret;
    }
    $ret = $sU->showHtmlListTitle($s2);
    $s.="<center><span class='navBar'>$s2</span></center>";
    $s.=$s1;
    $s.="</td><td valign='top'>";
    $sU = new SubsForumList;
    $ret = $sU->showHtmlList($s1,$subs);
    if ($ret!=ok) {
        return $ret;
    }
    $ret = $sU->showHtmlListTitle($s2);
    $s.="<center><span class='navBar'>$s2</span></center>";
    $s.=$s1;
    $s.="</tr></table>";
    if ($subs) $s.="<table width='100%' border='0'><tr><td valign='top'>";
    $sU = new SubsTopicList;
    $ret = $sU->showHtmlList($s1,$subs);
    if ($ret!=ok) {
        return $ret;
    }
    $ret = $sU->showHtmlListTitle($s2);
    $s.="<center><span class='navBar'>$s2</span></center>";
    $s.=$s1;
    if ($subs) {
        $s.="</td><td valign='top'>";
        $sU = new SubsReplyList;
        $ret = $sU->showHtmlList($s1);
        if ($ret!=ok) {
            return $ret;
        }
        $ret = $sU->showHtmlListTitle($s2);
        $s.="<center><span class='navBar'>$s2</span></center>";
        $s.=$s1;
        $s.="</tr></table>";
    }
    $s.="</td></tr></table>";
    return ok;
}
function showSubscribe()
{
    global $langTxt,$subscription,$subsInfo,$zorumuser;
    $s="";
    $s.="<table border='0' width='100%' cellspacing='0' cellpadding='0'><tr><td class='table'>\n";
    $s.="<table border='0' width='100%' cellspacing='1' cellpadding='2'><tr class='headerbg'>\n";
    $s.="<th align='center'>";
    if ($zorumuser->email="") return $s;
    if ($subscription&subs_all_new_mess) {
        goForward( $tempRoll, "unsubscribe");
        $txt=$langTxt["unsubs_all_new_mess"];
    }
    else {
        goForward( $tempRoll, "subscribe");
        $txt=$langTxt["subs_all_new_mess"];
    }
    $tempRoll->type=subs_all_new_mess;
    if ($subscription&subs_all_new_mess) {
        $txt=$langTxt["unsubs_all_new_mess"];
    }
    else $txt=$langTxt["subs_all_new_mess"];
    $s.=$tempRoll->generAnchor($txt,"listItem");
    $s.="</th><th align='center'>";
    if ($subscription&subs_all_new_topic) {
        goForward( $tempRoll, "unsubscribe");
        $txt=$langTxt["unsubs_all_new_topic"];
    }
    else {
        goForward( $tempRoll, "subscribe");
        $txt=$langTxt["subs_all_new_topic"];
    }
    $tempRoll->type=subs_all_new_topic;
    $s.=$tempRoll->generAnchor($txt,"listItem");
    $s.="</th></tr></table>";
    $s.="</td></tr></table>";
    return $s;
}
function canRate($base)
{
    global $zorumuser,$zorumrecognised,$zorumauthlevel,$regOnlyRate;
    if($zorumuser->id==$base->ownerId) return FALSE;
    if($regOnlyRate=="yes" && $zorumrecognised) return TRUE;
    if( ($zorumrecognised || $zorumauthlevel==Loginlib_GuestLevel) &&
          $regOnlyRate=="no") return TRUE;
    return FALSE;
}
function initializeSubscriptions()
{
    global $zorumuser,$subscription,$subsInfo;
    $subsForumIds = array();
    $subsInfo = array();
    $subsInfo["forummess"] = array();
    $subsInfo["forumtopic"] = array();
    $subsInfo["topics"] = array();
    $subsInfo["usertomess"] = array();
    $subsInfo["usertotopic"] = array();
    $subsInfo["reply"] = array();
    $subsInfo["favuser"] = array();
    $subsInfo["favforum"] = array();
    $subsInfo["favtopic"] = array();
    $subsInfo["poll_vote"] = array();
    $sub = new Subscribe;
    $query="SELECT * FROM subscribe_zorum WHERE userid=$zorumuser->id";
    $ret = $sub->loadObjectsSQL($query,$list, TRUE);
    if ($ret==not_found_in_db) {
        return ok;
    }
    if ($ret!=ok) {
        return $ret;
    }
    $subscription=0x0;
    for($i=0;isset($list[$i]);$i++) {
        $subscription|=$list[$i]->type;
        if ($list[$i]->type==subs_forum_new_mess) {
            $subsInfo["forummess"][$list[$i]->classid]=1;
        }
        elseif ($list[$i]->type==subs_forum_new_topic) {
            $subsInfo["forumtopic"][$list[$i]->classid]=1;
        }
        elseif ($list[$i]->type==subs_topic_new_mess) {
            $subsInfo["topics"][$list[$i]->classid]=1;
        }
        elseif ($list[$i]->type==subs_user_new_mess) {
            $subsInfo["usertomess"][$list[$i]->classid]=1;
        }
        elseif ($list[$i]->type==subs_user_new_topic) {
            $subsInfo["usertotopic"][$list[$i]->classid]=1;
        }
        elseif ($list[$i]->type==subs_reply) {
            $subsInfo["reply"][$list[$i]->classid]=1;
        }
        elseif ($list[$i]->type==fav_user) {
            $subsInfo["favuser"][$list[$i]->classid]=1;
        }
        elseif ($list[$i]->type==fav_forum) {
            $subsInfo["favforum"][$list[$i]->classid]=1;
        }
        elseif ($list[$i]->type==fav_topic) {
            $subsInfo["favtopic"][$list[$i]->classid]=1;
        }
        elseif ($list[$i]->type==poll_vote) {
            $subsInfo["poll_vote"][$list[$i]->classid]=1;
        }
    }
    return ok;
}
?>
