<?php
// This file serves as an example of how to realize a custom theme.

$zorumSkin->bg="white";
$zorumSkin->textcol="#000033";
$zorumSkin->linkcol="#000066";
$zorumSkin->line="#8c0000";
$zorumSkin->thboxheaderbg="#8c0000";
$zorumSkin->thboxcellbg="#000000";
$zorumSkin->thboxactcellbg="#222222";
$zorumSkin->thboxfooterbg="#8c0000";

$iP="$dotDot/themes/Soap";

$pollLineBg="$iP/darkblue.gif";
$pollCellBg="$iP/backdot.gif";
$pollStrongerBg="$iP/backdot-header.gif";

// The purpose of this function is to "frame" the fix content of a 
// portal box with a custom design.
// The parameters:
// $s: the output of the function - an HTML-code that displays a box.
// $headerText: the header of the box, it can also be empty
// $innerText: the inner content of the box, it can also be an array
//             in case of a menu box
// $footerText: the footer of the box, it can be empty
// $active: if $innerText is an array (represents a menu list), $active
//          shows which menu item is the active one. -1 means none of
//          them is active, 0 means the first item is active, etc.
function showPortalBox( &$s, $headerText, $innerText, $footerText="", 
                        $active=-1 )
{
    global $iP;
    
    $s="";
    $s.="<table cellspacing=0 cellpadding=0 width='100%' border=0>\n";
    $s.="<tr>\n";
    $s.="<td><img src='$iP/up-left.gif' width='15'></td>\n";
    $s.="<td align=middle width='100%' background='$iP/up.jpg'><img src='$iP/blank.gif'></td>\n";
    $s.="<td><img src='$iP/up-right.gif' width='15'></td>\n";
    $s.="</tr>\n";
    $s.="<tr>\n";
    $s.="<td background='$iP/left.jpg'><img src='$iP/blank.gif' width='15'></td>\n";
    $s.="<td background='$iP/backdot.gif'>";
    $s.="<table cellspacing='0' cellpadding='0' width='100%' border='0'>\n";
    if ($headerText!="") 
    {
        $s.="<tr>";
        $s.="<td align='center'>";
        $s.="<table cellspacing='0' cellpadding='0' width='100%' border='0'>\n";
        $s.="<tr>\n";
        $s.="<td><img src='$iP/up-left-header.jpg' width='14' height='10'></td>\n";
        $s.="<td align='middle' width='100%' background='$iP/up-header.jpg' height='10'><img src='$iP/blank.gif'></td>\n";
        $s.="<td><img src='$iP/up-right-header.jpg' width='15' height='10'></td>\n";
        $s.="<tr>\n";
        $s.="<td background='$iP/left-header.jpg'><img src='$iP/blank.gif' width='14'></td>\n";
        $s.="<td background='$iP/backdot-header.gif'>";
        
        $s.=$headerText;
        
        $s.="</td>\n";
        $s.="<td background='$iP/right-header.jpg'><img src='$iP/blank.gif' width='15'></td>\n";
        $s.="</tr>\n";
        $s.="<tr>\n";
        $s.="<td><img src='$iP/down-left-header.jpg' width='14' height='19'></td>\n";
        $s.="<td align='middle' width='100%' background='$iP/down-header.jpg' height='19'><img src='$iP/blank.gif'></td>\n";
        $s.="<td><img src='$iP/down-right-header.jpg' width='15' height='19'></td>\n";
        $s.="</tr></table><br></td>\n";
        $s.="</tr>\n";
    }    
    $s.="<tr><td>\n";
    
    if( is_array($innerText) ) 
    {
        foreach($innerText as $item) $s.="$item<br>\n";
    }    
    else $s.="$innerText<br>\n";
    
    $s.="</td></tr>";
    if ($footerText!="") 
    {
        $s.="<tr>";
        $s.="<td align='center'><br>";
        $s.="<table cellspacing='0' cellpadding='0' width='100%' border='0'>\n";
        $s.="<tr>\n";
        $s.="<td><img src='$iP/up-left-header.jpg' width='14' height='10'></td>\n";
        $s.="<td align='middle' width='100%' background='$iP/up-header.jpg' height='10'><img src='$iP/blank.gif'></td>\n";
        $s.="<td><img src='$iP/up-right-header.jpg' width='15' height='10'></td>\n";
        $s.="<tr>\n";
        $s.="<td background='$iP/left-header.jpg'><img src='$iP/blank.gif' width='14'></td>\n";
        $s.="<td background='$iP/backdot-header.gif'>\n";
        
        $s.=$footerText;
        
        $s.="</td>\n";
        $s.="<td background='$iP/right-header.jpg'><img src='$iP/blank.gif' width='15'></td>\n";
        $s.="</tr>\n";
        $s.="<tr>\n";
        $s.="<td><img src='$iP/down-left-header.jpg' width='14' height='19'></td>\n";
        $s.="<td align='middle' width='100%' background='$iP/down-header.jpg' height='19'><img src='$iP/blank.gif'></td>\n";
        $s.="<td><img src='$iP/down-right-header.jpg' width='15' height='19'></td>\n";
        $s.="</tr></table></td>\n";
        $s.="</tr>\n";
    }    
    
    $s.="</table></td>\n";
    $s.="<td align='right' background='$iP/right.jpg'><img src='$iP/blank.gif' width='15'></td>\n";
    $s.="</tr>\n";
    $s.="<tr>\n";
    $s.="<td background='$iP/down-left.gif'><img src='$iP/blank.gif' width='15' height='5'></td>\n";
    $s.="<td align='middle' width='100%' background='$iP/down.jpg' height='5'><img src='$iP/blank.gif'></td>\n";
    $s.="<td><img src='$iP/down-right.gif' width='15' height='5'></td>\n";
    $s.="</tr>\n";
    $s.="</table>\n";
    return ok;
}
?>
