<?php
function showTools($base,$rights,&$s)
{
    global $zorumroll;
    $s=$s1=$s2=$s3=$s4=$s5="";
    $className = get_class($base);
    if( $zorumroll->method!="showdetails" ) $s1=showDetailsTool($base);
    $ret=$base->showModTool($s2, $rights);
    if ($ret!=ok) {
        return $ret;
    }            
    $ret=$base->showDelTool($s3, $rights);
    if ($ret!=ok) {
        return $ret;
    }
    hasAdminRights( $isAdm );
    if( $isAdm && $className=="user" )
    {
        $ret=showAdmTool($base,$s4);
        if ($ret!=ok) {
            return $ret;
        }
    }    
    elseif( $className=="group" )
    {
        $ret=$base->showGroupTool($s4, $rights);
        if ($ret!=ok) {
            return $ret;
        }
    }    
    $ret=showLockTool($base,$s5, $rights);
    if ($ret!=ok) {
        return $ret;
    }
    if( $s1!="" || $s2!="" || $s3!="" || $s4!="" || $s5!="" )
    { 
        $s.= $s1=="" ? $s1 : "$s1 ";
        $s.= $s2=="" ? $s2 : "$s2 ";
        $s.= $s3=="" ? $s3 : "$s3 ";
        $s.= $s4=="" ? $s4 : "$s4 ";
        $s.= $s5=="" ? $s5 : "$s5 ";
    }    
    return ok;
}
function showModTool($base,&$s, $rights)
{
    global $langTxt;
    $s="";
    if (!isset($rights[Priv_modify])) {
        $ret=$base->hasObjectRights($hasRight,Priv_modify);
        if ($ret!=ok) {
            return $ret;
        }
    }
    else $hasRight = $rights[Priv_modify];
    if ($hasRight) {    
        goForward( $tempRoll, "modify" );
        $tempRoll->id = $base->id;
        $s.=$tempRoll->generImageAnchor("i/edit.gif",
                                   $langTxt["icon_modify"],20,20);
        global $zorumroll;
        if (strstr($zorumroll->class,"forummessage")) {
            $s.="&nbsp;";
            $s.=$tempRoll->generAnchor($langTxt["icon_modify"],
                                       "listItem");
            $s.="&nbsp;&nbsp;&nbsp;";
        }
    }
    return ok;
}
function showDelTool($base,&$s, $rights)
{
    global $langTxt;
    $s="";
    if (!isset($rights[Priv_delete])) {
        $ret=$base->hasObjectRights($hasRight,Priv_delete);
        if ($ret!=ok) {
            return $ret;
        }
    }
    else $hasRight = $rights[Priv_delete];
    if ($hasRight) {    
        goForward( $tempRoll, "delete" );
        $tempRoll->id = $base->id;
        $s.=$tempRoll->generImageAnchor("i/delete.gif",
                                   $langTxt["icon_delete"],16,20);
        global $zorumroll;
        if (strstr($zorumroll->class,"forummessage")) {
            $s.="&nbsp;";
            $s.=$tempRoll->generAnchor($langTxt["icon_delete"],
                                       "listItem");
            $s.="&nbsp;&nbsp;&nbsp;";
        }
    }
    return ok;
}
function showLockTool($base,&$s,$rights)
{
    global $langTxt;
    $s="";
    if( !isset($base->status) ) {
        return ok;
    }
    if( isset($base->iscat) && $base->iscat=="yes") {
        return ok;
    }
    if (!isset($rights[Priv_modify])) {
        $ret=$base->hasObjectRights($hasRight,Priv_modify);
        if ($ret!=ok) {
            return $ret;
        }
    }
    else $hasRight = $rights[Priv_modify];
    if ($hasRight &&
        ($base->status=="forum_opened"||$base->status=="forum_closed"))
    {
        goForward( $tempRoll, "lock" );
        $tempRoll->id = $base->id;
        if ($base->status=="forum_opened") {
            $s.=$tempRoll->generImageAnchor("i/lock.gif",
                                       $langTxt["icon_lock"],12,20);
        }
        else {
            $s.=$tempRoll->generImageAnchor("i/unlock.gif",
                                       $langTxt["icon_unlock"],18,20);
        }
    }
    return ok;
}
function showAdmTool($base,&$s)
{
    global $zorumuser;
    global $langTxt;
    $s="";
    goForward( $tempRoll, "changeAdmStatus" );
    $tempRoll->id = $base->id;
    if ($base->isAdm=="yes") {
        $s.=$tempRoll->generImageAnchor("i/removeadm.gif",
                                   $langTxt["removeAdmRights"],21,20);
    }
    else {
        $s.=$tempRoll->generImageAnchor("i/giveadm.gif",
                                   $langTxt["giveAdmRights"],21,16);
    }
    return ok;
}
function showDetailsTool($base)
{
    global $langTxt;
    $s="";
    goForward( $tempRoll, "showDetails", $base );
    $s.=$tempRoll->generImageAnchor("i/property.gif",
                               $langTxt["icon_details"],16,20);
    global $zorumroll;
    if (strstr($zorumroll->class,"forummessage")) {
        $s.="&nbsp;";
        $s.=$tempRoll->generAnchor($langTxt["icon_details"],
                                   "listItem");
        $s.="&nbsp;&nbsp;&nbsp;";
    }
    return $s;
}
function showNewTool($base, &$s, $rights)
{
    global $langTxt;
    $s="";
    if (!isset($rights[Priv_create])) {
        $ret=$base->hasObjectRights($hasRight,Priv_create);
        if ($ret!=ok) {
            return $ret;
        }
    }
    else $hasRight = $rights[Priv_create];
    if ($hasRight) {
        goForward( $tempRoll, "create" );
        $ret = $base->showNewToolPlusUrl($tempRoll);
        if ($ret!=ok) {
            return $ret;
        }
        $label=$langTxt[$tempRoll->class."_newitem"];
        $s.=$tempRoll->generAnchor($label, "command");
        $s.="<p>";
    }
}
function showSortTool($base, $attr)
{
    global $zorumroll;
    global $langTxt;
    $s = "";
    goForward( $tempRoll, "sort", $base );
    $typ=$base->getTypeInfo();
    $val=$typ["attributes"][$attr];
    $className = get_class($base);
    $sorta_name = $className."sorta";
    $sortd_name = $className."sortd";
    unset($tempRoll->{$sortd_name});
    unset($tempRoll->{$sorta_name});
    if(isTreeView() || 
       !in_array("sorta",$val) && !in_array("sortd",$val))
    {
        return $s;
    }    
    if ($zorumroll->{$sorta_name}=="rateavg") {
        $zorumroll->{$sorta_name}="rate";
    }
    if ($zorumroll->{$sortd_name}=="rateavg") {
        $zorumroll->{$sortd_name}="rate";
    }
    if ($zorumroll->{$sorta_name}=="" && $zorumroll->{$sortd_name}==""){
        $sortCriteriaName = $className."SortCriteria";
        global $$sortCriteriaName;
        $zorumRollHacked=TRUE;
        $slices = explode("_", $$sortCriteriaName);
        $attrName = $slices[0];
        $direction = $slices[1];
        if ($direction=="ASC") $zorumroll->{$sorta_name}=$attrName;
        else $zorumroll->{$sortd_name}=$attrName;
    }
    else $zorumRollHacked=FALSE;
    $sort="";
    if ($zorumroll->{$sorta_name}==$attr) $sort="D";
    if ($zorumroll->{$sortd_name}==$attr) $sort="A";
    if ($sort=="" && isset($typ["sorta"]) &&
        $typ["sorta"]==$attr &&
        $zorumroll->{$sorta_name}=="" &&
        $zorumroll->{$sortd_name}=="")
    {
        $sort="D";
    }
    if ($sort=="" && isset($typ["sortd"]) &&
        $typ["sortd"]==$attr &&
        $zorumroll->{$sorta_name}=="" &&
        $zorumroll->{$sortd_name}=="")
    {
        $sort="A";
    }
    if ($zorumroll->{$sorta_name}=="rate") {
        $zorumroll->{$sorta_name}="rateavg";
    }
    if ($zorumroll->{$sortd_name}=="rate") {
        $zorumroll->{$sortd_name}="rateavg";
    }
    if ($attr=="rate") $attr="rateavg";
    $s.="<br>";
    if ($sort!="") {
        if ($sort=="A") $tempRoll->{$sorta_name}=$attr;
        else $tempRoll->{$sortd_name}=$attr;
        if ($sort=="A") {
            $s.=$tempRoll->generImageAnchor(
                "i/asc.gif",$langTxt["icon_asc"],11,11);
        }
        else {
            $s.=$tempRoll->generImageAnchor(
                "i/desc.gif",$langTxt["icon_desc"],11,11);
        }
        $s.="</a>";
    }
    else {
        $tempRoll->{$sorta_name}=$attr;
        $s.=$tempRoll->generImageAnchor(
            "i/asc.gif",$langTxt["icon_asc"],11,11);
        unset($tempRoll->{$sorta_name});
        $tempRoll->{$sortd_name}=$attr;
        $s.=$tempRoll->generImageAnchor(
            "i/desc.gif",$langTxt["icon_desc"],11,11);
        unset($tempRoll->{$sortd_name});
    }
    if ($zorumRollHacked) {
        $zorumroll->{$sorta_name}="";
        $zorumroll->{$sortd_name}="";
    }
    return $s;
}
function showRangeSelector( $base )
{
    global $zorumroll;
    global $TST;
    global $TSTret;
    global $blockSize, $rangeBlockSize;
    if($TST) $TSTret="";
    $typ = $base->getTypeInfo();
    $bs=$blockSize;       
    $rbs=$rangeBlockSize;       
    $ro=(int)($zorumroll->rangeoffset);
    $off=$zorumroll->offset;
    $ret = getCount($count);
    if ($ret==general_mysql_error) 
    {
        if($TST) $TSTret="general_mysql_error";
        return $ret;
    }                   
    if( $count<=$bs || $bs==0 || $rbs==0 )
    {
        if($TST) $TSTret="No range selector.";
        return "";
    }
    $tempRollWithoutOffset=$zorumroll;
    unset($tempRollWithoutOffset->offset);
    $tempRollWithoutOffset->method = "showhtmllist";
    $tempRollWithoutRangeOffset=$zorumroll;
    unset($tempRollWithoutRangeOffset->rangeoffset);
    $tempRollWithoutRangeOffset->method = "showhtmllist";
    $s="";
    if( $off!=0 )
    {
        $tempRoll = $tempRollWithoutOffset;
        $tempRoll->offset = 0;
        $s.=$tempRoll->generImageAnchor("i/first.gif", "First", 38, 18);
        $s.="&nbsp;&nbsp;";
        if( $TST ) $TSTret="First:     $url";
        $newOffset = max($off-$bs, 0);
        $tempRoll->offset = $newOffset;
        $s.=$tempRoll->generImageAnchor("i/prev.gif", "Prev", 23, 18);
        $s.="&nbsp;&nbsp;";
        if( $TST ) $TSTret.="Prev:      $url";
    }
    if( $ro!=0 )
    {
        $newOffset = max($ro-$rbs, 0);
        $tempRoll = $tempRollWithoutRangeOffset;
        $tempRoll->rangeoffset = $newOffset;
        $s.=$tempRoll->generAnchor("...", "rangeSelector");
        $s.="&nbsp;&nbsp;";
        if( $TST ) $TSTret.="PrevRange: $url";
    }
    $upperRange=$count;
    for( $i=$ro; $i<$ro+$rbs; $i++ )
    {
        $newOffset = $i * $bs;
        if( $newOffset>=$count ) break;
        $tempRoll = $tempRollWithoutOffset;
        $tempRoll->offset = $newOffset;
        $s.=$tempRoll->generAnchor($i+1, "rangeSelector");
        $s.="&nbsp;&nbsp;";
        $upperRange = min($newOffset+$bs, $count);
        if( $TST ) $TSTret.="Range:     $url";
    }        
    if( $count > $upperRange )           
    {
        if( ($ro + $rbs -1) * $bs > $count )
        {
            $newOffset = ($count / $bs)+1-$rbs;
        }
        else
        {
            $newOffset = $ro + $rbs;
        }
        $tempRoll = $tempRollWithoutRangeOffset;
        $tempRoll->rangeoffset = $newOffset;
        $s.=$tempRoll->generAnchor("...", "rangeSelector");
        $s.="&nbsp;&nbsp;";
        if( $TST ) $TSTret.="NextRange: $url";
    }
    if( $off + $bs < $count )
    {
        $newOffset = $off+$bs;
        $tempRoll = $tempRollWithoutOffset;
        $tempRoll->offset = $newOffset;
        $s.=$tempRoll->generImageAnchor("i/next.gif", "Next", 23, 18);
        $s.="&nbsp;&nbsp;";
        if( $TST ) $TSTret.="Next:      $url";
        if( $count % $bs ) $newOffset = $count - ($count % $bs);
        else $newOffset = $count - $bs;
        $tempRoll->offset = $newOffset;
        $s.=$tempRoll->generImageAnchor("i/last.gif", "Last", 38, 18);
        $s.="&nbsp;&nbsp;";
        if( $TST ) $TSTret.="Last:      $url";
    }
    return $s;
}
function showForumJump( $currentPid, &$s )
{
    global $langTxt;
    $s="";
    $forums = new Forum;
    global $forum_typeInfo;
    $query="SELECT * FROM ".$forum_typeInfo["tableName"].
           " ORDER BY treeidx";
    $ret=loadObjectsSQL( $forums,"",$forums);
    if ($ret==not_found_in_db) {
        return ok;
    }
    elseif( $ret ) {
        return $ret;
    }
    global $readAccessArr;
    $ret=readAccessForums();
    if( $ret ) {
        return $ret;
    } 
    hasAdminRights($isAdm);
    if( !$isAdm )   
    {
        $newList = array();
        foreach( $forums as $forum )
        {
            if (isset($readAccessArr[$forum->id]))
            {
                $newList[] = $forum;
            }
        }
        $forums=$newList;
    }
    goForward($tempRoll, "topics");
    global $x;
    $s.="\n<FORM METHOD='GET' ACTION='$tempRoll->scriptname?x=$x'>\n";
    $s.=$tempRoll->generHiddenFields();
    $s.="<table border='0'>\n";
    $len=40;
    foreach($forums as $forum) {
        if (strlen($forum->name)>$len) {
            $fn=substr($forum->name,0,$len)."...";
        }
        else $fn=$forum->name;
        $labels[$forum->id]=htmlspecialchars($fn);
        $vals[$forum->id]=$forum->id;
    }
    $s.=generSelectField("rollid",$langTxt["forumjump"]." : ","",$labels,
                        $vals,$currentPid,FALSE,0,"jumpbg","jumperTool",FALSE);
    $s.="<td class='jumpbg'><input type='submit' value='".
        $langTxt["ok"]."' name='submit'></td>\n";
    $s.="</table>\n";
    $s.="</FORM>\n";
    return ok;
}
function showTopicJump( $currentPid, $currentTid, &$s )
{
    global $langTxt;
    $s="";
    $topics = new ForumTopic;
    global $forumtopic_typeInfo;
    $query="SELECT * FROM ".$forumtopic_typeInfo["tableName"].
           " WHERE pid=$currentPid".
           " ORDER BY creationtime DESC LIMIT 15";
    $ret=loadObjectsSQL( $topics,$query,$topics);
    if ($ret==not_found_in_db) {
        return ok;
    }
    elseif( $ret ) {
       return $ret;
    }
    goForward($tempRoll, "messages");
    global $x;
    $s.="\n<FORM METHOD='GET' ACTION='$tempRoll->scriptname?x=$x'>\n";
    $s.=$tempRoll->generHiddenFields();
    $s.="<table border='0'>\n";
    $len=40;
    foreach($topics as $topic) {
        if (strlen($topic->subject)>$len) {
            $ts=substr($topic->subject,0,$len)."...";
        }
        else $ts=$topic->subject;
        $labels[$topic->id]=htmlspecialchars($ts);
        $vals[$topic->id]="$currentPid,$topic->id";
    }
    $s.=generSelectField("rollid",$langTxt["topicjump"]." : ","",$labels,
                        $vals,$currentTid,FALSE,0,"jumpbg","jumperTool",FALSE);
    $s.="<td class='jumpbg'><input type='submit' value='".
        $langTxt["ok"]."' name='submit'></td>\n";
    $s.="</table>\n";
    $s.="</FORM>\n";
    return ok;
}   
?>
