<?php
    function ubbhandler_create(&$base, $overrulePrivilege=FALSE)
    {
        global $zorumuser;
        global $whatHappened;
        global $submit;
        global $langTxt;
        global $infoText;
        $whatHappened = "form_submitted";
        if( $submit==$langTxt["cancel"] )
        {   
            $infoText[] = $langTxt["operation_cancelled"];
            return ok;
        } 
        $base->ubbBegin = str_replace('\\', '\\\\', $base->ubbBegin);
        $base->replacementBegin = str_replace('\\', '\\\\', $base->replacementBegin);
        if( isset($base->ubbEnd) && isset($base->replacementEnd))
        {
            $base->ubbEnd = str_replace('\\', '\\\\', $base->ubbEnd);
            $base->replacementEnd = str_replace('\\', '\\\\', $base->replacementEnd);
        }    
        $ret = privilegeCreate($base, $overrulePrivilege);
        return $ret;     
    }  
    function ubbhandler_modify(&$base, $whereFields="", $overrulePrivilege=FALSE)
    {
        global $zorumuser;
        global $whatHappened;
        global $submit;
        global $langTxt;
        global $infoText;
        if( $submit==$langTxt["cancel"] )
        {   
            $infoText[] = $langTxt["operation_cancelled"];
            return ok;
        } 
        $base->ubbBegin = str_replace('\\', '\\\\', $base->ubbBegin);
        $base->replacementBegin = str_replace('\\', '\\\\', $base->replacementBegin);
        $base->ubbEnd = str_replace('\\', '\\\\', $base->ubbEnd);
        $base->replacementEnd = str_replace('\\', '\\\\', $base->replacementEnd);
        $ret = privilegeModify($base, $whereFields,$overrulePrivilege);
        return $ret;     
    }       
    function ubbhandler_delete(&$base, $whereFields="",$overrulePrivilege=FALSE)
    {
        global $submit;
        global $langTxt;
        global $whatHappened;
        global $infoText;
        global $zorumroll;
        $whatHappened = "form_submitted";
        if( $submit==$langTxt["no"] )
        {   
            $infoText[] = $langTxt["operation_cancelled"];
            return ok;
        } 
        $ret=load($base,$whereFields="");
        if ($ret!=ok) {
            return $ret;
        }        
        $ret=privilegeDelete($base,$whereFields="",$overrulePrivilege);
        if ($ret==not_found_in_db) {
            $infoText[] = $langTxt["no_such_object"];
            return ok;
        }
        if ($ret!=ok) {
            return $ret;
        }
        if( $zorumroll->frommethod=="showdetails" )      
        {
            $zorumroll->frommethod = "showhtmllist";
            $zorumroll->fromid = 0;
        }
        return ok;     
    }  
?>